name = "渴了? 喝茶!!!"
description = "渴了? 喝茶!!! \n Thirsty for Tea[DST]汉化 \n 原作者：Desblat & Bunions"
author = "ifeng"
version = "1.0.1"

forumthread = ""

api_version = 10

priority = 0.1

all_clients_require_mod = true

--dont_starve_compatible = false
--reign_of_giants_compatible = false
dst_compatible = true

icon_atlas = "modicon.xml"
icon = "modicon.tex"
----------------------
--[[
To-Do:
1) D O N E.  Well burning, well destroy stages, fixes
2) D O N E. water holes, maximum ammount, too close spawn 
3) D O N E. Pouring water on ground to deal with fire/dryied plants
4) D O N E. Aqua stuff wetness

5) D O N E. Water poisoning and cleanising, well, barrel
6) D O N E. Wheels: cleanise wheels / poison wheels
7) D O N E. Thirst meter.
8) D O N E. Actions for Getting Water, Filling with ice, Ocean water

7) D O N E. WX water
8) REPLACED. Water spiders, barrels/containers/bottles drinking, pond spawn, spider wave attacks

9) D O N E. Barrels spawn monkeys, barrels freeze in winter
10) D O N E. Wells can be repaired with cutstone.
11) D O N E. implement motherfucking SNAKES.


12) Empty Bottle perish color
13) Ring girl
14) Water dishes
15) Water droplet for condensers can we make it idiot proof?
16) activate pond --->drink from pond



--]]

local opt_Empty = {{description = "", data = 0}}
local function Title(title,hover)
return {
name=title,
hover=hover,
options=opt_Empty,
default=0,
}
end
local SEPARATOR = Title("")


configuration_options =
{

	Title("难度"),

    {
        name = "DIFFICULTY",
		label = "总体难度",
		hover = "口渴速度，口渴时的伤害，喝水增长的数值，水坏掉的速度",
        options =
        {
            {description = "默认", data = 0},
            {description = "难", data = 0.2},
            {description = "很难", data = 0.4},
            {description = "专家", data = 0.66},
            {description = "简单", data = -0.25},
            {description = "新手", data = -0.6},
		},
        default = 0,	
	},
	
	{
        name = "Thirst Damage",
		label = "口渴时的伤害",
		hover = "当你口渴时，你会受到多少伤害",
        options =
        {
            {description = "默认", data = 1},
            {description = "1.25x", data = 1.25},
            {description = "1.5x", data = 1.5},
            {description = "2x", data = 2},
            {description = "0.75x", data = 0.75},
            {description = "0.5x", data = 0.5},
		},
        default = 1,	
	},
	
	
	{
		name = "Thirst rate",
		label = "口渴速度",
		hover = "改变口渴的速度",
		options =
		{
			{description = "0.45x", data = 0.45},
			{description = "0.6x", data = 0.6},
			{description = "0.8x", data = 0.8},
			{description = "默认", data = 1},
			{description = "1.2x", data = 1.2},
			{description = "1.35x", data = 1.35},
			{description = "1.55x", data = 1.55}
		},
		default = 1,
	},
	
	{
		name = "Water spoil rate",
		label = "水坏掉的速度",
		hover = "改变水坏掉的速度",
		options =
		{
			{description = "0.4x", data = 0.4},
			{description = "0.6", data = 0.6},
			{description = "0.8x", data = 0.8},
			{description = "默认", data = 1},
			{description = "1.33x", data = 1.33},
			{description = "1.66x", data = 1.66},
			{description = "2x", data = 2},
			{description = "2.5x", data = 2.5},
		},
		default = 1,
	},
	
	---
	
	
	SEPARATOR,
	Title("水壶"),
	{
        name = "THIRST_NEED_ONLY_ZAVARKA",
		label = "水壶不需要水",
		hover = "各种水壶只需要茶块或茶叶既可以制作饮料 \n 你不需要往壶里倒水来泡茶",

        options =
        {
            {description = "需要水", data = 1},
			{description = "不需要水", data = 0},
        },
        default = 1,	
	},
	
	SEPARATOR,
	Title("HUD选项"),
	
    {
        name = "CustomeHUD",
		label = "口渴值的状态栏位置调整开关",
		hover = "允许在下面的菜单中调整你的口渴值状态栏位置",

        options =
        {
            {description = "关", data = 0},
			{description = "开", data = 1},
        },
        default = 0,	
	},

    {
        name = "Badge_Position1",
		label = "Y轴",
		hover = "向上或向下移动",

        options =
        {
            {description = "默认", data = 1},
			{description = "高", data = 0.55},
			{description = "更高", data = 0.05},
			{description = "低", data = 1.55},
			{description = "更低", data = 2.4},			
        },
        default = 1,

	},
	
    {
        name = "Badge_Position2",
		label = "X轴",
		hover = "向左或向右移动",

        options =
        {
            {description = "默认", data = 0},
			{description = "左", data = 0.55},
			{description = "更左", data = 1.1},
			{description = "右", data = -.55},
			{description = "更右", data = -1.1},			
        },
        default = 0,

	},	
	
	SEPARATOR,
	Title("瓶子和冷凝器选项"),
	
    {
        name = "Water_Per_Sip",
		label = "嘴巴的大小（可以容纳多少水）",
		hover = "你一次可以喝多少水",
		
        options =
        {
            {description = "默认", data = 50},
			{description = "75", data = 75},
			{description = "100", data = 100},
        },
        default = 50,	
	},
	
    {
        name = "Bottle_Uses",
		label = "瓶子的耐久度",
		hover = "瓶子可以用多少次",	
        options =
        {
            {description = "默认", data = 1},
			{description = "1.5x", data = 1.5},
			{description = "2x", data = 2},
			{description = "2.5x", data = 2.5},
			{description = "3x", data = 3},
		},
        default = 1,	
	},
	--[[
    {
        name = "Can move water catchers",
		label = "Movable water catchers",
		hover = "Is it possible to put water catcher into inventory once it was placed?",		

        options =
        {
            {description = "No", data = false},
			{description = "Yes", data = true},

		},
        default = false,	
	},--]]
	

	SEPARATOR,
	Title("世界生成选项"),
	{
		name = "Hydromato gen",
		label = "储水植物的数量",
		hover = "生成地图时储水植物的数量",
		options =
		{
			{description = "无", data = 0},
			{description = "少", data = 1},
			{description = "默认", data = 1.5},
			{description = "多", data = 2.2},
		},
		default = 1.5,
	},
	{
		name = "Tea tree gen",
		label = "茶树的数量",
		hover = "生成地图时茶树的数量",
		options =
		{
			{description = "无", data = 0},
			{description = "少", data = 1},
			{description = "默认", data = 1.5},
			{description = "多", data = 2.2},
		},
		default = 1.5,
	},
	{
		name = "Ivan chai gen",
		label = "蝴蝶花茶丛的数量",
		hover = "生成地图时茶树的数量",
		options =
		{
			{description = "无", data = 0},
			{description = "少", data = 1},
			{description = "默认", data = 1.5},
			{description = "多", data = 2.2},
		},
		default = 1.5,
	},

	
	{
		name = "THIRST_REPLACE_MARBLE_KNIGHT",
		label = "把骑士雕像换成喷泉",
		hover = "把骑士雕像换成喷泉 \n 建议在世界生成前没有使用这个mod的时候使用 \n 在摧毁它时起作用",		
		options =
		{
			{description = "否", data = false},
			{description = "是", data = true},
			---{description = "Blah", data = 1, hover = "true"},
		},
		default = false,
	},	
	{
		name = "THIRST_REPLACE_MARBLE_ROOK",
		label = "把战车雕像换成喷泉",
		hover = "把战车雕像换成喷泉 \n 建议在世界生成前没有使用这个mod的时候使用 \n 在摧毁它时起作用",		
		options =
		{
			{description = "否", data = false},
			{description = "是", data = true},
			---{description = "Blah", data = 1, hover = "true"},
		},
		default = false,
	},
	{
		name = "THIRST_REPLACE_MARBLE_BISHOP",
		label = "把主教雕像换成喷泉",
		hover = "把主教雕像换成喷泉 \n 建议在世界生成前没有使用这个mod的时候使用 \n 在摧毁它时起作用",		
		options =
		{
			{description = "否", data = false},
			{description = "是", data = true},
			---{description = "Blah", data = 1, hover = "true"},
		},
		default = false,
	},


	

	{
		name = "des_thirst_water_holes_max",
		label = "在世界上生成的井水洞的数量",
		hover = "在世界上生成的井水洞的数量",		
		
		options =
		{
			{description = "2", data = 2},
			{description = "3", data = 3},
			{description = "4", data = 4},
			{description = "5", data = 5},
			{description = "6", data = 6},			
			{description = "7", data = 7},
			{description = "8", data = 8},
			{description = "9", data = 9},			
			{description = "10", data = 10},
			{description = "11", data = 11},
			{description = "12", data = 12},
			{description = "13有点多吧", data = 13},
			{description = "15你真的要这么多吗", data = 15},
			{description = "17会不会得密集恐惧症", data = 17},
		},
		default = 9,
	},	
	
	{
		name = "THIRST_REPLACE_GRAVES_CHANCE",
		label = "用井洞代替墓穴",
		hover = "用井洞代替墓穴的百分比 \n 建议在世界生成前没有使用这个mod的时候使用 \n 在挖掘坟墓时起作用",		
		
        options =
        {
			{description = "关闭", data = 0},	
			{description = "5%", data = 0.05},				
			{description = "10%", data = 0.1},	
			{description = "15%", data = 0.15},	
			{description = "20%", data = 0.2},	
			{description = "25%", data = 0.25},	
			{description = "30%", data = 0.30},	
		},
		default = 0.05,
	},	
	
	
	
	{
		name = "THIRST_REPLACE_GRAVES_RIVERS_CHANCE",
		label = "用河流代替坟墓",
		hover = "用河流代替坟墓的百分比 \n 建议在世界生成前没有使用这个mod的时候使用 \n 在挖掘坟墓时起作用",		
		
        options =
        {
			{description = "关", data = 0},	
			{description = "5%", data = 0.05},				
			{description = "10%", data = 0.1},	
			{description = "15%", data = 0.15},	
			{description = "20%", data = 0.2},	
			{description = "25%", data = 0.25},	
			{description = "30%", data = 0.30},	
		},
		default = 0.05,
	},	
	
	
	SEPARATOR,
	Title("兼容"),
	{
		name = "THIRST_DISABLE_AW_ITEMS",
		label = "关闭和‘A Water’mod中相似的项目",
		hover = "关闭和‘A Water’mod中相似的项目 \n 建议使用，因为有很多类似的项目 \n 这会影响：水井，水桶，桶，杯子",		
		
        options =
        {
			{description = "关", data = 0},	
			{description = "开", data = 1},	
		},
		default = 0,
	},	

	
	--[[
	{
		name = "THIRST_ENABLE_POST_GEN",
		label = "Post gen in old worlds",
		hover = "Should we create holes and fountain in the old worlds?",
		options =
		{
			{description = "Yeah", data = true},
			{description = "Nah", data = false},
			---{description = "Blah", data = 1, hover = "true"},
		},
		default = true,
	},	
--]]
}

server_filter_tags = {"thirst", "water", "realism", "tea"}