modimport("libs/env.lua")

use "data/init"



_G = GLOBAL
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH



PrefabFiles = 
{
	-----craftables
	"bottlegold",
	"des_watercatchers",
	"aquagem",
	"des_aqua_staff",
	"des_cleantablets",
	
	----chainik
	"des_chainik",
	"des_samovar",
	
	"des_chai_tree",
	"des_water_trees",
	
	----chai tablets
	"des_chai_tabl",
	"des_chai_leaf",
	
	-----structures
	"des_water_well",
	"des_well_hole",
	"des_well_rack",
	"des_statue_charlie",
	"des_water_barrel",
	
	-----other items
	"hmato_item",
	"hmato",
	
	-------dummies
	"watertrapsign",
	"des_waterdrop_fake",
	"des_aqua_missle",
	"des_speical_dummy",
	
	------monsters
	---"des_water_spiders",
	"des_water_snake",
	
	--RIVER
	"des_river",
	"des_river_fishinghole",
	"des_river_sinkhole",
	"des_river_circle",
	"des_raindrop"
}

Assets = 
{

	---Slot update---
	Asset("ATLAS", "images/inventoryimages/frozen.xml"),
	
	Asset("ATLAS", "images/inventoryimages/des_cwater_empty.xml"),
	
	Asset("ATLAS", "images/inventoryimages/des_cwater_quoter.xml"),
	Asset("ATLAS", "images/inventoryimages/des_cwater_half.xml"),
	
	Asset("ATLAS", "images/inventoryimages/des_cwater_third.xml"),
	Asset("ATLAS", "images/inventoryimages/des_cwater_full.xml"),

	-----------------


	Asset("ATLAS", "images/inventoryimages/aquagem.xml"),
	Asset("ATLAS", "images/inventoryimages/aquagem_thirst.xml"),

	----chai----
	---tablets---
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_black.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_green.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_ivan.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_coffee.xml"),
	---
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_shadow.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_stinger.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_pine.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_coal.xml"),
	---
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_dragonheal.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_glommerhunger.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_honeysanity.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_tabl_fishwet.xml"),
	---
	Asset("ATLAS", "images/inventoryimages/des_chai_leaf_ivan.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_leaf_black.xml"),
	Asset("ATLAS", "images/inventoryimages/des_chai_leaf_green.xml"),
	------------------
	
	
	--Asset("ATLAS", "images/inventoryimages/aquagem.xml"),
	Asset("ATLAS", "images/inventoryimages/des_tab_chai.xml"),

	------------
	
	----------des_chainik
	Asset("ATLAS", "images/inventoryimages/des_chainik.xml"),	
	----------des_samovar
	Asset("ATLAS", "images/inventoryimages/des_samovar.xml"),
    Asset("IMAGE", "images/inventoryimages/des_samovar.tex"),

	----------des_enkettle
	Asset("ATLAS", "images/inventoryimages/des_enkettle_empty.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle_water.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle_boil.xml"),
	Asset("ATLAS", "images/inventoryimages/des_enkettle.xml"),
	----------
	
	Asset("ATLAS", "images/inventoryimages/des_aqua_staff.xml"),

	Asset("ATLAS", "images/inventoryimages/hmato.xml"),

	Asset("ATLAS", "images/inventoryimages/bottlegold.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlewood.xml"),
	
	
	Asset("ATLAS", "images/inventoryimages/bottlehot.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecold.xml"),
	
	Asset("ATLAS", "images/inventoryimages/bottleswglass.xml"),
	Asset("ATLAS", "images/inventoryimages/bottleswglass_dummy.xml"),

----	Asset("ATLAS", "images/inventoryimages/des_bottle_moonrock.xml"),
----	Asset("ATLAS", "images/inventoryimages/des_thul_bottle.xml"),
	------
	Asset("ATLAS", "images/inventoryimages/symbol0-5new.xml"), -------bottle_moonrock
	Asset("ATLAS", "images/inventoryimages/symbol0-6new.xml"), -------thulicite_bottle
	
	Asset("ATLAS", "images/inventoryimages/watrtab.xml"),
	Asset("ATLAS", "images/inventoryimages/waterback.xml"),
	Asset("ATLAS", "images/inventoryimages/watertrap.xml"),
	Asset("ATLAS", "images/inventoryimages/bottlecup.xml"),
	Asset("ATLAS", "images/inventoryimages/pondbuild.xml"),
	
	

	Asset("ATLAS", "images/inventoryimages/watertrap_grass.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_grass.tex"),

	Asset("ATLAS", "images/inventoryimages/watertrap_silk.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_silk.tex"),
	
	Asset("ATLAS", "images/inventoryimages/watertrap_gem.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_gem.tex"),


	Asset("ATLAS", "images/inventoryimages/watertrap_dest.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_dest.tex"),
	
	
	Asset("ATLAS", "images/inventoryimages/watertrap_dest2.xml"),
	Asset("IMAGE", "images/inventoryimages/watertrap_dest2.tex"),

	-----------buckets
	Asset("ATLAS", "images/inventoryimages/des_bucket_steel_empty.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_steel_empty.tex"),

	Asset("ATLAS", "images/inventoryimages/des_bucket_steel_full.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_steel_full.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_bucket_wood_full.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_wood_full.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_bucket_wood_empty.xml"),
	Asset("IMAGE", "images/inventoryimages/des_bucket_wood_empty.tex"),	

	-----------ancient bottles
	Asset("ATLAS", "images/inventoryimages/des_new_thulbottle.xml"),
	Asset("IMAGE", "images/inventoryimages/des_new_thulbottle.tex"),	
	
	Asset("ATLAS", "images/inventoryimages/des_new_moonbottle.xml"),
	Asset("IMAGE", "images/inventoryimages/des_new_moonbottle.tex"),	

	---------- potato cup
	Asset("ATLAS", "images/inventoryimages/des_potato_cup.xml"),
	Asset("IMAGE", "images/inventoryimages/des_potato_cup.tex"),	
		
	-----------well
	Asset("ATLAS", "images/inventoryimages/des_water_well.xml"),
	Asset("ATLAS", "images/inventoryimages/des_well_rack_craft.xml"),


	----------barrel
	Asset("ATLAS", "images/inventoryimages/des_water_barrel.xml"),
    Asset("IMAGE", "images/inventoryimages/des_water_barrel.tex"),

	
	--------statue
	Asset("ATLAS", "images/inventoryimages/des_statue_charlie.xml"),
    Asset("IMAGE", "images/inventoryimages/des_statue_charlie.tex"),
	
	
	--------tablets
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_white.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_white.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_pink.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_pink.tex"),
	
	Asset("ATLAS", "images/inventoryimages/des_cleantablets_grey.xml"),
    Asset("IMAGE", "images/inventoryimages/des_cleantablets_grey.tex"),
		
		
		
		
	-------badge
	
	Asset("IMAGE", "images/frame.tex"),
    Asset("ATLAS", "images/frame.xml"),
    Asset("IMAGE", "images/background.tex"),
    Asset("ATLAS", "images/background.xml"),
		
		
    Asset("IMAGE", "images/thirst_level-0.tex"),
    Asset("ATLAS", "images/thirst_level-0.xml"),
    Asset("IMAGE", "images/thirst_level-1.tex"),
    Asset("ATLAS", "images/thirst_level-1.xml"),
    Asset("IMAGE", "images/thirst_level-2.tex"),
    Asset("ATLAS", "images/thirst_level-2.xml"),
    Asset("IMAGE", "images/thirst_level-3.tex"),
    Asset("ATLAS", "images/thirst_level-3.xml"),
    Asset("IMAGE", "images/thirst_level-4.tex"),
    Asset("ATLAS", "images/thirst_level-4.xml"),
    Asset("IMAGE", "images/thirst_level-5.tex"),
    Asset("ATLAS", "images/thirst_level-5.xml"),
    Asset("IMAGE", "images/thirst_level-6.tex"),
    Asset("ATLAS", "images/thirst_level-6.xml"),
    Asset("IMAGE", "images/thirst_level-7.tex"),
    Asset("ATLAS", "images/thirst_level-7.xml"),
    Asset("IMAGE", "images/thirst_level-8.tex"),
    Asset("ATLAS", "images/thirst_level-8.xml"),
    Asset("IMAGE", "images/thirst_level-9.tex"),
    Asset("ATLAS", "images/thirst_level-9.xml"),
    Asset("IMAGE", "images/thirst_level-10.tex"),
    Asset("ATLAS", "images/thirst_level-10.xml"),
    Asset("IMAGE", "images/thirst_level-11.tex"),
    Asset("ATLAS", "images/thirst_level-11.xml"),
    Asset("IMAGE", "images/thirst_level-12.tex"),
    Asset("ATLAS", "images/thirst_level-12.xml"),
    Asset("IMAGE", "images/thirst_level-13.tex"),
    Asset("ATLAS", "images/thirst_level-13.xml"),
    Asset("IMAGE", "images/thirst_level-14.tex"),
    Asset("ATLAS", "images/thirst_level-14.xml"),
    Asset("IMAGE", "images/thirst_level-15.tex"),
    Asset("ATLAS", "images/thirst_level-15.xml"),
    Asset("IMAGE", "images/thirst_level-16.tex"),
    Asset("ATLAS", "images/thirst_level-16.xml"),
    Asset("IMAGE", "images/thirst_level-17.tex"),
    Asset("ATLAS", "images/thirst_level-17.xml"),
    Asset("IMAGE", "images/thirst_level-18.tex"),
    Asset("ATLAS", "images/thirst_level-18.xml"),
    Asset("IMAGE", "images/thirst_level-19.tex"),
    Asset("ATLAS", "images/thirst_level-19.xml"),
    Asset("IMAGE", "images/thirst_level-20.tex"),
    Asset("ATLAS", "images/thirst_level-20.xml"),
    Asset("IMAGE", "images/thirst_level-21.tex"),
    Asset("ATLAS", "images/thirst_level-21.xml"),		
	

	
	---BADGE
    Asset("IMAGE", "images/thirstmeter_bg.tex"),
    Asset("ATLAS", "images/thirstmeter_bg.xml"),
	
	
    Asset("IMAGE", "images/kidney-0.tex"),
    Asset("ATLAS", "images/kidney-0.xml"),
    Asset("IMAGE", "images/kidney-1.tex"),
    Asset("ATLAS", "images/kidney-1.xml"),
    Asset("IMAGE", "images/kidney-2.tex"),
    Asset("ATLAS", "images/kidney-2.xml"),
    Asset("IMAGE", "images/kidney-3.tex"),
    Asset("ATLAS", "images/kidney-3.xml")

	
}

AddMinimapAtlas("images/inventoryimages/des_water_barrel.xml")
AddMinimapAtlas("images/inventoryimages/des_water_well.xml")
AddMinimapAtlas("images/inventoryimages/des_statue_charlie.xml")
AddMinimapAtlas("images/inventoryimages/des_wellhole.xml")


TUNING.AW_THIRST = 0
TUNING.THIRST_DISABLE_AW_ITEMS = GetModConfigData("THIRST_DISABLE_AW_ITEMS")




TUNING.MOVETRAPS = false ---GetModConfigData("Can move water catchers")
TUNING.DES_BOTTLE_GREENFONT = true ---false ----- true	-----------GetModConfigData("Bottles green font")
TUNING.THIRST_TALK_AMMOUNT = GetModConfigData("Talk to remind about thirst") or 1

----TUNING.THIRST_ENABLE_POST_GEN = GetModConfigData("THIRST_ENABLE_POST_GEN")


TUNING.THIRST_ALWAYS_SHOW_OCEAN = true ---- GetModConfigData("THIRST_ALWAYS_SHOW_OCEAN")





TUNING.THIRST_NEED_ONLY_ZAVARKA = GetModConfigData("THIRST_NEED_ONLY_ZAVARKA")



TUNING.THIRST_WATER_SPOIL_TUNE = GetModConfigData("Water spoil rate")

TUNING.THIRST_RATE_TUNE = GetModConfigData("Thirst rate")
TUNING.THIRST_DAMAGE_TUNE = 1  ----*GetModConfigData("Thirst Damage")


TUNING.THIRST_DIFFILCULTY = GetModConfigData("DIFFICULTY")
TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT = 1 - TUNING.THIRST_DIFFILCULTY
TUNING.THIRST_DIFFILCULTY_THIRST_SPEED = (1 + TUNING.THIRST_DIFFILCULTY*1.25)*0.6*TUNING.THIRST_RATE_TUNE

TUNING.THIRST_DIFFILCULTY_WATER_CATCHERS_NERF = 0.5



TUNING.DES_THIRST_LAG_FACTOR = 1

TUNING.DES_THIRST_WATER_HOLES_MAX = GetModConfigData("des_thirst_water_holes_max")
TUNING.DES_THIRST_ALLOW_FOUNTAIN = GetModConfigData("Fountain_spawn")



TUNING.THIRST_CUSTOM_HUD = GetModConfigData("CustomeHUD")
TUNING.THIRST_BADGE_POSITION1 = GetModConfigData("Badge_Position1")
TUNING.THIRST_BADGE_POSITION2 = GetModConfigData("Badge_Position2")

TUNING.THIRST_REPLACE_GRAVES_CHANCE = GetModConfigData("THIRST_REPLACE_GRAVES_CHANCE")
TUNING.THIRST_REPLACE_GRAVES_RIVERS_CHANCE = GetModConfigData("THIRST_REPLACE_GRAVES_RIVERS_CHANCE")

TUNING.THIRST_REPLACE_MARBLE_KNIGHT = GetModConfigData("THIRST_REPLACE_MARBLE_KNIGHT")
TUNING.THIRST_REPLACE_MARBLE_ROOK = GetModConfigData("THIRST_REPLACE_MARBLE_ROOK")
TUNING.THIRST_REPLACE_MARBLE_BISHOP = GetModConfigData("THIRST_REPLACE_MARBLE_BISHOP")


TUNING.THIRST_DES_FOUNTAIN_DRYDAYS = 2
TUNING.THIRST_DES_FOUNTAIN_FULLDAYS = 6


TUNING.THIRST_WATER_PER_SIP = GetModConfigData("Water_Per_Sip")
TUNING.THIRST_DURABLE_REBALANCE = TUNING.THIRST_WATER_PER_SIP*0.02
TUNING.THIRST_DURABLE_BUFF = GetModConfigData("Bottle_Uses")*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

---TUNING.THIRST_BOTTLE_FOODTYPE = "ELEMENTAL"--- TUNING.THIRST_BOTTLE_FOODTYPE   ----- GetModConfigData("BottleIs")

TUNING.WATER_POISONED_DMG = 5
TUNING.WATER_POISONED_HUNGER = 5
TUNING.WATER_POISONED_SANITY = 5

TUNING.SALT_TO_DAMAGE = 1*TUNING.THIRST_DIFFILCULTY_THIRST_SPEED
TUNING.BAD_TO_HUNGERDAMAGE = 0.25*TUNING.THIRST_DIFFILCULTY_THIRST_SPEED
TUNING.DES_POISON_TO_DAMAGE = 1*TUNING.THIRST_DIFFILCULTY_THIRST_SPEED

TUNING.BOTTLE_THUL_USES = math.ceil(100/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.BOTTLE_MOON_USES = math.ceil(50/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.BOTTLE_GLASS_USES = math.ceil(13/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.BOTTLE_WOOD_USES = math.ceil(13/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.BOTTLE_GOLD_USES = math.ceil(25/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.BOTTLE_CUP_USES = math.ceil(3*TUNING.THIRST_DURABLE_BUFF)
TUNING.DES_BUCKET_WOOD_USES = math.ceil(17/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)
TUNING.DES_BUCKET_STEEL_USES = math.ceil(30/TUNING.THIRST_DURABLE_REBALANCE*TUNING.THIRST_DURABLE_BUFF)




TUNING.BOTTLE_THUL_WATER = 450*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.BOTTLE_MOON_WATER = 450*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.BOTTLE_GLASS_WATER = 150*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.BOTTLE_WOOD_WATER = 200*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.BOTTLE_GOLD_WATER = 450*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.BOTTLE_CUP_WATER = 50*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.DES_BUCKET_WOOD = 350*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.DES_BUCKET_STEEL = 500*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.DES_DEST_FILTER_SIZE = 300*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT
TUNING.DES_DEST_METAL_SIZE = 600*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

TUNING.DES_WATER_BARREL_SIZE = 1000*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT

---this one shouldn't be changed!
TUNING.DES_CHAINIK_SIZE = 300
TUNING.DES_SAMOVAR_SIZE = 600
TUNING.DES_ENCHAINIK_SIZE = 450


TUNING.DES_WATER_FIREFIGHTER = 1000
TUNING.DES_WATER_FIREFIGHTER_WATERMULT = 2


TUNING.DES_MOONBOTTLE_FILL = 1
TUNING.DES_THULBOTTLE_FILL = 1


TUNING.POND_WATER_RESTORE = 50
TUNING.PONDBULD_WATER = 900 * 2


TUNING.WATERTRAP_GAIN_SPEED_GRASS = 0.2*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT * 0.45 * TUNING.THIRST_DIFFILCULTY_WATER_CATCHERS_NERF
TUNING.WATERTRAP_GAIN_SPEED_SILK = 0.5*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT * 0.45 * TUNING.THIRST_DIFFILCULTY_WATER_CATCHERS_NERF
TUNING.WATERTRAP_GAIN_SPEED_GEM = 0.7*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT * 0.45 * TUNING.THIRST_DIFFILCULTY_WATER_CATCHERS_NERF
TUNING.WATERBOTTLEMOON_SPEED = 0.7*TUNING.THIRST_DIFFILCULTY_GAIN_SPEED_MULT * 0.33



TUNING.WATER_SPOIL_SPEED = -0.25*TUNING.THIRST_DIFFILCULTY_THIRST_SPEED

----badness per second per 100 water inside of container
TUNING.DES_WATER_SPOIL_SPEED = 0.04 * TUNING.THIRST_DIFFILCULTY_THIRST_SPEED * TUNING.THIRST_WATER_SPOIL_TUNE
TUNING.DES_WATER_SPOIL_BUCKET_FACTOR = 3
TUNING.DES_WATER_SPOIL_GLASS_FACTOR = 0.7
TUNING.DES_WATER_SPOIL_BARREL_FACTOR = 0.5

TUNING.DES_WATER_SPOIL_CHAINIK_FACTOR = 0.25
TUNING.DES_WATER_SPOIL_ENCHAINIK_FACTOR = 0.1

TUNING.DES_WATER_SPOIL_BUCKET = TUNING.DES_WATER_SPOIL_SPEED*TUNING.DES_WATER_SPOIL_BUCKET_FACTOR
TUNING.DES_WATER_SPOIL_GLASS = TUNING.DES_WATER_SPOIL_SPEED*TUNING.DES_WATER_SPOIL_GLASS_FACTOR
TUNING.DES_WATER_SPOIL_BARREL = TUNING.DES_WATER_SPOIL_SPEED*TUNING.DES_WATER_SPOIL_BARREL_FACTOR

TUNING.DES_WATER_SPOIL_CHAINIK = TUNING.DES_WATER_SPOIL_SPEED*TUNING.DES_WATER_SPOIL_CHAINIK_FACTOR
TUNING.DES_WATER_SPOIL_ENCHAINIK = TUNING.DES_WATER_SPOIL_SPEED*TUNING.DES_WATER_SPOIL_ENCHAINIK_FACTOR



TUNING.THRIST_SWEATSTART_MIN_TEMPERATURE = TUNING.OVERHEAT_TEMP*0.75

TUNING.DES_SNAKE_SPAWN_ONDRINK_CHANCE = 0.2
TUNING.DES_SNAKE_SPAWN_CACTUS_CHANCE = 0.3



--------------------------
TUNING.DES_XSTEP = 77
TUNING.DES_YSTEP = 160
TUNING.DES_YSIP = 80
TUNING.DES_YSP = 80

--------------------------


local require = GLOBAL.require
local STRINGS = GLOBAL.STRINGS
local RECIPETABS = GLOBAL.RECIPETABS
local Ingredient = GLOBAL.Ingredient
local FOODTYPE = GLOBAL.FOODTYPE
local TECH = GLOBAL.TECH
local TUNING = GLOBAL.TUNING
local TheSim = GLOBAL.TheSim
local Vector3 = GLOBAL.Vector3
local ACTIONS = GLOBAL.ACTIONS
local TheNet = GLOBAL.TheNet

-----------------------------------------------
-----------------------------------------------
--
local containers = require "containers"

local params = {}

local containers_widgetsetup_base = containers.widgetsetup
function containers.widgetsetup(container, prefab, data, ...)
    local t = params[prefab or container.inst.prefab or inst.widgetsetup]
    if t ~= nil then
        for k, v in pairs(t) do
            container[k] = v
        end
        container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
    else
        containers_widgetsetup_base(container, prefab, data, ...)
    end
end--]]
--
local function makeCatcher()
    local container =
    {
        widget =
        {
			slotpos =
			{
				Vector3(0, 0.75*(64 + 32 + 8 + 4)+8, 0), 
				--Vector3(0, -16, 0),
				--Vector3(0, -(32 + 4), 0), 
				Vector3(0, -(64 + 32 + 8 + 4)*0.75-16, 0),
			},
			animbank = "ui_cookpot_1x4",
			animbuild = "ui_cookpot_1x4",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	
    return container
end
local function makeDist()
    local container =
    {
        widget =
        {
			slotpos =
			{
				Vector3(0, 0.8*(64 + 32 + 8 + 4)+8, 0), 
				--Vector3(0, -16, 0),
				Vector3(0, -8, 0), 
				Vector3(0, -(64 + 32 + 8 + 4)*0.8-16, 0),
			},
			animbank = "ui_cookpot_1x4",
			animbuild = "ui_cookpot_1x4",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	
    return container
end
local function MakeOneSlot()
    local container =
    {
        widget =
        {
			slotpos =
			{
				---Vector3(0, 0.8*(64 + 32 + 8 + 4)+8, 0), 
				--Vector3(0, -16, 0),
				Vector3(0, -8, 0), 

			},
			animbank = "ui_cookpot_1x4",
			animbuild = "ui_cookpot_1x4",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	
    return container
end



--params.watercatcher = makeCatcher()
--params.des_waterdist = makeDist()
--params.des_water_well = MakeOneSlot()



--[[

function params.des_waterdist.itemtestfn(container, item, slot)
    if item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
        return true
    end

    return false
end


function params.watercatcher.itemtestfn(container, item, slot)
    if item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
        return true
    end

    return false
end

function params.des_water_well.itemtestfn(container, item, slot)
    if item:HasTag("des_well_valid") or item:HasTag("des_bucket") then
        return true
    end

    return false
end--]]



for k, v in pairs(params) do
    containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, v.widget.slotpos ~= nil and #v.widget.slotpos or 0)
end--]]


-----------------------------------------------
-----------------------------------------------





----------------------------------------------
----------------------STRINGS
----------------------------------------------

modimport("thirst_new_actions.lua")

----------------------------------------------
-----------------end---------------------
----------------------------------------------






----------------------------------------------
----------------------STRINGS
----------------------------------------------

modimport("thirst_strings.lua")

----------------------------------------------
-----------------end---------------------
----------------------------------------------



----50 water will turn into 50 drink in 15 seconds
----Requires NORMAL level of fire
TUNING.THIRST_DEF_SIP_BOIL_TIME = 30

TUNING.THIRST_DEFAULT_SIP_SIZE = 50




TUNING.BOTTLE_DRINKS_TYPE = {}

TUNING.THIRST_LAST_TEA_NUM = 1

local function addtypedrink(cup_name, zavarka, health, hunger, sanity, thirst, special, alco, name_show, spoilspeed)
	
	TUNING.BOTTLE_DRINKS_TYPE[zavarka] = {}

	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["hunger"] = hunger or 0
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["health"] = health or 0
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["sanity"] = sanity or 0
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["thirst"] = thirst or 0

	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["special"] = special or ""
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["alco"] = alco or 0
	
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["name_show"] = name_show or ""
	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["cup_name"] = cup_name or 0

	TUNING.BOTTLE_DRINKS_TYPE[zavarka]["spoilspeed"] = spoilspeed or 0
	print("-------------ADDING DRINK----------------")
	print(cup_name, zavarka, health, hunger, sanity, thirst, special, alco, spoilspeed, name_show)
	print("-----------------------------------------")

end

local total_chai_nerf = 0.75
local hp = 1*total_chai_nerf
local hun = 1*total_chai_nerf
local s = 1*total_chai_nerf
local th = 1*total_chai_nerf

local sp = 0.5
--[[
	   Prefab("tee_g", tea_g, assets),
	   Prefab("tee_m", tea_m, assets),
	   Prefab("tee_s", tea_s, assets),
	   Prefab("tee_r", tea_r, assets),
	   Prefab("tee_r2", tea_r2, assets),
	   Prefab("tea_berry", tea_berry, assets),
	   Prefab("tea_carrot", tea_carrot, assets),
	   Prefab("tea_cactus", tea_cactus, assets),
	   Prefab("tea_banana", tea_banana, assets),
	   Prefab("tea_honey", tea_honey, assets)
	   
	   
local calories_per_day = 75

local function thirsteat(food,inst)
	if not inst.components.thirst then
		return
	end
--	local food=data.food
	local self=food.components.edible
	
	if inst:HasTag("player") then
		if food.components.cwater then
		elseif food.prefab=="icecream" or food.prefab=="berryshake" then
			inst.components.thirst:DoDelta(150)
		elseif food.prefab=="goatmilk" or food.prefab=="cookedmilk" or food.prefab=="cactus_flower" then
			inst.components.thirst:DoDelta(100)
		elseif food.prefab=="watermelon" or food.prefab=="cactus_meat" then
			inst.components.thirst:DoDelta(50)
		elseif food.prefab=="ice" or food.prefab=="rawmilk" then
			inst.components.thirst:DoDelta(25)
		elseif food.prefab=="hmato_item" then
			inst.components.thirst:DoDelta(20)
		elseif food.prefab=="lightbulb" or food.prefab=="berries_juicy" then
			inst.components.thirst:DoDelta(15)
		elseif self.foodtype=="VEGGIE" then
			inst.components.thirst:DoDelta(self.healthvalue*0.25+self.hungervalue*0.33)
		elseif self.foodtype=="MEAT" and food.components.dryable then
			inst.components.thirst:DoDelta(self.healthvalue*0.5+self.hungervalue*0.25)
		
		elseif (food.prefab=="meat_dried") or (food.prefab=="monstermeat_dried") or (food.prefab=="humanmeat_dried") then
			inst.components.thirst:DoDelta(-15)
		elseif (food.prefab=="smallmeat_dried") then
			inst.components.thirst:DoDelta(-8)
	
		
		end
	end
end

        CALORIES_TINY = calories_per_day/8, -- berries
        CALORIES_SMALL = calories_per_day/6, -- veggies
        CALORIES_MEDSMALL = calories_per_day/4,
        CALORIES_MED = calories_per_day/3, -- meat
        CALORIES_LARGE = calories_per_day/2, -- cooked meat
        CALORIES_HUGE = calories_per_day, -- crockpot foods?
        CALORIES_SUPERHUGE = calories_per_day*2, -- crockpot foods?
		
        HEALING_TINY = 1,
        HEALING_SMALL = 3,
        HEALING_MEDSMALL = 8,
        HEALING_MED = 20,
        HEALING_MEDLARGE = 30,
        HEALING_LARGE = 40,
        HEALING_HUGE = 60,
        HEALING_SUPERHUGE = 100,		
		
        SANITY_SUPERTINY = 1,
        SANITY_TINY = 5,
        SANITY_SMALL = 10,
        SANITY_MED = 15,
        SANITY_MEDLARGE = 20,
        SANITY_LARGE = 33,
        SANITY_HUGE = 50,	
	   --]]

TUNING.DES_THIRST_SUPERTINY = 1
TUNING.DES_THIRST_SMALL = 3
TUNING.DES_THIRST_MEDSMALL = 8
TUNING.DES_THIRST_MED = 10
TUNING.DES_THIRST_MEDBIGGER = 15
TUNING.DES_THIRST_MEDIUM = 20
TUNING.DES_THIRST_MEDLARGE = 35
TUNING.DES_THIRST_DEFAULT_SIP = 50
TUNING.DES_THIRST_LARGE = 60
TUNING.DES_THIRST_HUGE = 80
TUNING.DES_THIRST_SUPERHUGE = 100
TUNING.DES_THIRST_NEARMAX = 150
TUNING.DES_THIRST_MAX = 200


TUNING.DES_THIRST_TEA_SPOIL_VERYFAST = 4
TUNING.DES_THIRST_TEA_SPOIL_FAST = 2
TUNING.DES_THIRST_TEA_SPOIL_NORMAL = 1
TUNING.DES_THIRST_TEA_SPOIL_BITSLOW = 0.75
TUNING.DES_THIRST_TEA_SPOIL_SLOW = 0.5
TUNING.DES_THIRST_TEA_SPOIL_SLOWER = 0.35
TUNING.DES_THIRST_TEA_SPOIL_VERYSLOW = 0.2
TUNING.DES_THIRST_TEA_SPOIL_FOREVER = 0.1

TUNING.DES_THIRST_TEA_SANITY_LARGE = 60

local seg_time_coffee = 30
local total_day_time_coffee = seg_time_coffee*16
TUNING.DES_THIRST_COFFEE_SPEED_MULT = 1.5
TUNING.DES_THIRST_COFFEE_TIME = total_day_time_coffee/2


TUNING.DES_THIRST_IVAN_CHAI_RESPAWN = total_day_time_coffee*8


TUNING.DES_THIRST_CHAITREE_REGROW_TIME = total_day_time_coffee*4
TUNING.DES_THIRST_CHAITREE_NUMBER = 2




TUNING.DES_THIRST_TEMP_TEA_SMALL = 5
TUNING.DES_THIRST_TEMP_TEA_NORMAL = 8
TUNING.DES_THIRST_TEMP_TEA_MED = 16
TUNING.DES_THIRST_TEMP_TEA_HUGE = 30


TUNING.DES_THIRST_SHADOW_BREW_TIME = 60
TUNING.DES_THIRST_BEE_BREW_TIME = 60

TUNING.DES_THIRST_HEAL_BOOST_TIME = 90
TUNING.DES_THIRST_SANITY_BOOST_TIME = 90
TUNING.DES_THIRST_HUNGER_BOOST_TIME = 90
TUNING.DES_THIRST_TEA_DRY_TIME = 90


TUNING.DES_THIRST_HEAL_BOOST_POWER = 0.5
TUNING.DES_THIRST_SANITY_BOOST_POWER = 0.5
TUNING.DES_THIRST_HUNGER_BOOST_POWER = 0.5

---DES--NORMAL DRINKS--
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	WARMTH_BONUS
addtypedrink("cup_coffe", "des_chai_tabl_coffee", 	   		0*hp,		TUNING.CALORIES_MEDSMALL*hun,		-TUNING.SANITY_SMALL*s, 0*th, 	"bustup", 		0, "咖啡",				TUNING.DES_THIRST_TEA_SPOIL_SLOW*sp, 0)
addtypedrink("cup_tee", "des_chai_tabl_black", 	   		TUNING.HEALING_TINY*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_MED*s, TUNING.DES_THIRST_DEFAULT_SIP*th, 	"", 		0, "红茶",				TUNING.DES_THIRST_TEA_SPOIL_SLOW*sp, 0)
addtypedrink("cup_tee", "des_chai_tabl_ivan", 	   		0*hp,		0*hun,		TUNING.SANITY_MED*s, TUNING.DES_THIRST_MEDBIGGER*th, 	"", 		0, "蝴蝶花茶",				TUNING.DES_THIRST_TEA_SPOIL_FAST*sp, 0)
addtypedrink("cup_tee", "des_chai_tabl_green", 	   		TUNING.HEALING_MEDSMALL*hp,		0*hun,		TUNING.SANITY_MED*s, TUNING.DES_THIRST_MEDSMALL*th, 	"", 		0, "绿茶",				TUNING.DES_THIRST_TEA_SPOIL_VERYSLOW*sp, 0)
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	

addtypedrink("cup_pine", "des_chai_tabl_pine", 	   		TUNING.HEALING_MEDSMALL*hp,		0*hun,		TUNING.SANITY_MED*s, 0*th, 	"", 		0, "松果茶",				TUNING.DES_THIRST_TEA_SPOIL_VERYSLOW*sp, TUNING.DES_THIRST_TEMP_TEA_MED)
addtypedrink("cup_coal", "des_chai_tabl_coal", 	   		TUNING.HEALING_MEDLARGE*hp,		0*hun,		0*s, 0*th, 	"", 		0, "木炭茶",				TUNING.DES_THIRST_TEA_SPOIL_FAST*sp, 0)

---DES--DRINKS WITH EFFECTS--
addtypedrink("cup_shadow", "des_chai_tabl_shadow", 	   		-TUNING.HEALING_MEDSMALL*hp,		0*hun,		-TUNING.SANITY_LARGE*s, 0*th, 	"shadow", 		0, "影子茶",				TUNING.DES_THIRST_TEA_SPOIL_FOREVER*sp, 0)
addtypedrink("cup_stinger", "des_chai_tabl_stinger", 	   		0*hp,		0*hun,		-TUNING.SANITY_MED*s, 0*th, 	"beebrew", 		0, "Bee Brew",				TUNING.DES_THIRST_TEA_SPOIL_VERYSLOW*sp, TUNING.DES_THIRST_TEMP_TEA_MED)
------
addtypedrink("cup_stinger", "des_chai_tabl_fishwet", 	   		0*hp,		TUNING.CALORIES_MEDSMALL*hun,		0*s, 0*th, 	"drybrew", 		0, "干燥茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp, 0)
addtypedrink("cup_stinger", "des_chai_tabl_honeysanity", 	   		TUNING.HEALING_MEDSMALL*hp,		0*hun,		TUNING.SANITY_MED*s, 0*th, 	"sanityboost", 		0, "醒脑蜂蜜茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp, 0)
addtypedrink("cup_stinger", "des_chai_tabl_glommerhunger", 	   		TUNING.HEALING_MEDSMALL*hp,		TUNING.CALORIES_MEDSMALL*hun,		TUNING.SANITY_SMALL*s, 0*th, 	"hungerboost", 		0, "饥饿格莱姆茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp, 0)
addtypedrink("cup_stinger", "des_chai_tabl_dragonheal", 	   		TUNING.HEALING_MED*hp,		0*hun,		0*s, 0*th, 	"healboost", 		0, "火龙果茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp, 0)
------
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	
---------------------------------



---FILI--NORMAL DRINKS ----
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_tea_berry", "tea_berry", 	  TUNING.HEALING_MEDSMALL*hp, 		TUNING.CALORIES_SMALL*hun, 	TUNING.SANITY_MED*s, 	TUNING.DES_THIRST_MED*th, 	"",			0, "浆果茶", 		TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp)
addtypedrink("cup_tea_carrot", "tea_carrot",  TUNING.HEALING_MEDSMALL*hp, 		TUNING.CALORIES_MEDSMALL*hun, 	TUNING.SANITY_TINY*s, 	TUNING.DES_THIRST_MED*th, 	"",			0, "胡萝卜茶", 		TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp)
addtypedrink("cup_tee", "tee_s", 	   		TUNING.HEALING_TINY*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_MED*s, TUNING.DES_THIRST_DEFAULT_SIP*th, 	"", 		0, "红茶",				TUNING.DES_THIRST_TEA_SPOIL_SLOW*sp)
addtypedrink("cup_tee", "tea_honey", 	   		TUNING.HEALING_MED*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_MED*s, 0*th, 	"", 		0, "Honey Tea",				TUNING.DES_THIRST_TEA_SPOIL_SLOW*sp)

-----
addtypedrink("cup_tea_banana", "tea_banana", 	   		TUNING.HEALING_LARGE*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_HUGE*s, TUNING.DES_THIRST_DEFAULT_SIP*th, 	"", 		0, "香蕉茶",				TUNING.DES_THIRST_TEA_SPOIL_SLOW*sp)
addtypedrink("cup_tea_cactus", "tea_cactus", 	   		TUNING.HEALING_SMALL*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_SMALL*s, TUNING.DES_THIRST_MEDLARGE*th, 	"", 		0, "仙人掌茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp)
addtypedrink("cup_tee", "tee_r2", 	   		TUNING.HEALING_TINY*hp,		TUNING.CALORIES_TINY*hun,		TUNING.SANITY_MED*s, TUNING.DES_THIRST_DEFAULT_SIP*th, 	"", 		0, "木槿花茶",				TUNING.DES_THIRST_TEA_SPOIL_FAST*sp)


---FILI--DRINKS WITH EFFECTS--
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_monster", "tee_m", 	   		-TUNING.HEALING_TINY*hp,		0*hun,		0*s, 0*th, 	"spider", 		-TUNING.SANITY_MED*s, "怪物茶",				TUNING.DES_THIRST_TEA_SPOIL_NORMAL*sp)
addtypedrink("cup_red", "tee_r", 	   		TUNING.HEALING_HUGE*hp,		TUNING.CALORIES_MED*hun,		TUNING.SANITY_HUGE*s, TUNING.DES_THIRST_MEDLARGE*th, 	"red", 		0, "龙红茶",				TUNING.DES_THIRST_TEA_SPOIL_FOREVER*sp)
addtypedrink("tee_g", "tee_g", 	   		0*hp,		0*hun,		0*s, 0*th, 	"ghost", 		0, "鬼魂茶",				TUNING.DES_THIRST_TEA_SPOIL_VERYFAST*sp)




--[[	   
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_water", "water",      0*hp,	5*hun, 			10*s, 	20*th, 	"", 		0, "Water", 						0.25*sp,	"")
addtypedrink("cup_tee", "blacktea", 	   		5*hp,		10*hun,		10*s, 	35*th, 	"", 		0, "Black Tea",				0.5*sp,	"tee_m")
addtypedrink("cup_coffe", "coffee",	  0*hp, 		TUNING.CALORIES_MEDSMALL*hun,	-TUNING.SANITY_MED*s, 	20*th, 	"coffee", 		0, "Coffee", 					0.5*sp,	"coffe_beans")
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_tea", "sleeptea", 	   		5*hp,		5*hun,		5*s, 	35*th, 	"sleep", 		0, "Herbal Tea",		0.5*sp,	"")
addtypedrink("cup_red", "redtea",	  20*hp, 		15*hun, 	25*s, 	50*th, 	"areasleep",			0, "Red Tea", 			0.25*sp, "")
addtypedrink("cup_monster", "monstertea",25*hp, 	-30*hun, 	-35*s, 	27*th, 	"monster",  0, 				"Monster Drink", 	0.1*sp, "")
addtypedrink("cup_beer", "beer", 	  25*hp, 		25*hun, 	55*s, 	35*th, 	"",			10, "Beer", 						1*sp, "")
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_blood_monster", "blood_monster", 	  -5*hp, 		-5*hun, 	-15*s, 	40*th, 	"",			0, "Monster Blood", 1*sp, "")
addtypedrink("cup_blood_animal", "blood_animal", 	  5*hp, 		5*hun, 	-5*s, 	40*th, 	"",			0, "Blood", 			1*sp, "")
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
addtypedrink("cup_tea_berry", "tea_berry", 	  15*hp, 		15*hun, 	15*s, 	40*th, 	"",			0, "Berry Tea", 		1*sp, "tea_berry")
addtypedrink("cup_tea_carrot", "tea_carrot", 	  15*hp, 		15*hun, 	15*s, 	40*th, 	"",			0, "Carrot Tea", 		1*sp, "tea_carrot")
addtypedrink("cup_tea_banana", "tea_banana", 	  45*hp, 		25*hun, 	45*s, 	75*th, 	"",			0, "Banana Tea", 		1*sp, "tea_banana")
addtypedrink("cup_tea_cactus", "tea_cactus", 	  45*hp, 		25*hun, 	45*s, 	75*th, 	"",			0, "Cactus Tea", 		1*sp, "tea_cactus")
addtypedrink("cup_tea_honey", "tea_honey", 	  15*hp, 		15*hun, 	15*s, 	40*th, 	"",			0, "Honey Tea", 		1*sp, "tea_honey")
---------------name,  			 health,	 hunger, 		рассудок, жажда, 	особое, 	алкоголь,		название для бутыли, порча,	префаб_заварки
--]]
-- RECIPES --
local nm,rec,gen, ch = _G.STRINGS.NAMES, _G.STRINGS.RECIPE_DESC, _G.STRINGS.CHARACTERS.GENERIC.DESCRIBE, _G.STRINGS.CHARACTERS

STRINGS.TABS.WATER = "水具"
GLOBAL.RECIPETABS['WATER'] = {str = "WATER", sort=3, icon = "watrtab.tex", icon_atlas = "images/inventoryimages/watrtab.xml"}



local bottlegoldxml = "images/inventoryimages/bottlegold.xml"
local bottlehotxml = "images/inventoryimages/bottlehot.xml"
local bottlecoldxml = "images/inventoryimages/bottlecold.xml"




-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000
--[[
local steel = 
if not KnownModIndex:IsModEnabled("workshop-635360350") then
		inst:ListenForEvent("death", OnDeathSkeleton)
end--]]



AddRecipe("watercatcher_grass", {Ingredient("cutgrass", 4), Ingredient("twigs", 5)}, RECIPETABS.WATER, TECH.NONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/watertrap_grass.xml", "watertrap_grass.tex")

AddRecipe("watercatcher_silk", {Ingredient("silk", 3), Ingredient("twigs", 5)}, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/watertrap_silk.xml", "watertrap_silk.tex")

AddRecipe("aquagem_thirst", { Ingredient("ice", 6),Ingredient("nightmarefuel", 2),Ingredient("marble", 1) }, RECIPETABS.WATER, TECH.MAGIC_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/aquagem_thirst.xml")

AddRecipe("watercatcher_gem", {Ingredient("aquagem_thirst", 1,"images/inventoryimages/aquagem_thirst.xml", "aquagem.tex"), Ingredient("nightmarefuel", 2), Ingredient("twigs", 5)}, RECIPETABS.WATER, TECH.MAGIC_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/watertrap_gem.xml", "watertrap_gem.tex")
--------------------------------------------
AddRecipe("waterdestcoal", {Ingredient("rope", 3), Ingredient("log", 6), Ingredient("charcoal", 5)}, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/watertrap_dest.xml", "watertrap_dest.tex")
AddRecipe("waterdestmetal", {Ingredient("transistor", 2),Ingredient("bottleswglass", 2, "images/inventoryimages/bottleswglass.xml"), Ingredient("boards", 2)}, RECIPETABS.WATER, TECH.SCIENCE_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/watertrap_dest2.xml", "watertrap_dest2.tex")

AddRecipe("des_chainik", {Ingredient("transistor", 2),Ingredient("twigs", 4)}, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_chainik.xml", "des_chainik.tex")

local des_samovar = AddRecipe("des_samovar", {Ingredient("goldnugget", 6), Ingredient("redgem", 1)}, GLOBAL.RECIPETABS.WATER,  GLOBAL.TECH.SCIENCE_TWO, "des_samovar_placer", 2)
des_samovar.atlas = "images/inventoryimages/des_samovar.xml"

local des_enkettle = AddRecipe("des_enkettle", {Ingredient("transistor", 2), Ingredient("gears", 1),Ingredient("bottleswglass", 2, "images/inventoryimages/bottleswglass.xml")}, RECIPETABS.WATER, TECH.SCIENCE_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_enkettle.xml", "des_enkettle.tex")


AddRecipe("bottlecup", { Ingredient("log", 1), Ingredient("cutgrass", 1) }, RECIPETABS.WATER, TECH.NONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/bottlecup.xml"
)
AddRecipe("bottlewood", { Ingredient("log", 3),Ingredient("flint", 4),Ingredient("cutgrass", 4) }, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/bottlewood.xml"
)
AddRecipe("bottleswglass", {Ingredient("nitre", 3),Ingredient("flint", 2)}, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/bottleswglass.xml"
)
AddRecipe("bottlegold", { Ingredient("papyrus", 2), Ingredient("goldnugget", 3),Ingredient("charcoal", 4) }, RECIPETABS.WATER, TECH.SCIENCE_TWO,
nil,nil,nil,nil,nil,
bottlegoldxml
)
AddRecipe("bottlehot", { Ingredient("bottlegold", 1,"images/inventoryimages/bottlegold.xml"), Ingredient("nightmarefuel", 3),Ingredient("redgem", 1) }, RECIPETABS.WATER, TECH.MAGIC_TWO,
nil,nil,nil,nil,nil,
bottlehotxml
)
AddRecipe("bottlecold", { Ingredient("bottlegold", 1,"images/inventoryimages/bottlegold.xml"), Ingredient("nightmarefuel", 3),Ingredient("bluegem", 1) }, RECIPETABS.WATER, TECH.MAGIC_TWO,
nil,nil,nil,nil,nil,
bottlecoldxml
)
AddRecipe("bottlemoon", { Ingredient("moonrockcrater", 1),Ingredient("aquagem_thirst", 1,"images/inventoryimages/aquagem_thirst.xml","aquagem.tex") }, RECIPETABS.WATER, TECH.MAGIC_THREE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_new_moonbottle.xml", "des_new_moonbottle.tex")
AddRecipe("bottlethul", { Ingredient("thulecite", 2),Ingredient("nightmarefuel", 4),Ingredient("slurtle_shellpieces", 2) }, RECIPETABS.WATER, TECH.ANCIENT_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_new_thulbottle.xml", "des_new_thulbottle.tex")


AddRecipe("des_aqua_staff", { Ingredient("spear", 1),Ingredient("aquagem_thirst", 1,"images/inventoryimages/aquagem_thirst.xml","aquagem.tex") }, RECIPETABS.WATER, TECH.MAGIC_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_aqua_staff.xml"
)

local des_water_barrel = AddRecipe("des_water_barrel", {Ingredient("boards", 3), Ingredient("rope", 2)}, GLOBAL.RECIPETABS.WATER,  GLOBAL.TECH.SCIENCE_ONE, "des_water_barrel_placer", 2)
des_water_barrel.atlas = "images/inventoryimages/des_water_barrel.xml"

AddRecipe("des_bucket_wood", {Ingredient("log", 6), Ingredient("rope", 2)}, RECIPETABS.WATER, TECH.SCIENCE_ONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_bucket_wood_empty.xml", "des_bucket_wood_empty.tex")

AddRecipe("des_bucket_steel", {Ingredient("nitre", 4), Ingredient("goldnugget", 4), Ingredient("rope", 2)}, RECIPETABS.WATER, TECH.SCIENCE_TWO,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_bucket_steel_empty.xml", "des_bucket_steel_empty.tex")


AddRecipe("des_cleantablets_pink", -- name
	{Ingredient("ash", 9),Ingredient("nightmarefuel",2), Ingredient("glommerfuel", 1)},
	RECIPETABS.SCIENCE,
	TECH.MAGIC_TWO,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	6, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_cleantablets_pink.xml", -- atlas
	"des_cleantablets_pink.tex") -- image
	
AddRecipe("des_cleantablets_white", -- name
	{Ingredient("ash", 6),Ingredient("charcoal",6), Ingredient("lightbulb", 3)},
	RECIPETABS.SCIENCE,
	TECH.SCIENCE_TWO,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	nil, -- builder_tag
	"images/inventoryimages/des_cleantablets_white.xml", -- atlas
	"des_cleantablets_white.tex") -- image

AddRecipe("des_cleantablets_grey", -- name
	{Ingredient("ash", 6),Ingredient("charcoal",3), Ingredient("spoiled_food", 6)},
	RECIPETABS.SCIENCE,
	TECH.SCIENCE_TWO,
	nil, -- placer
	nil, -- min_spacing
	nil, -- nounlock
	3, -- numtogive
	"wx78_special_tablets", -- builder_tag
	"images/inventoryimages/des_cleantablets_grey.xml", -- atlas
	"des_cleantablets_grey.tex") -- image
	
	


AddRecipe("des_water_well", {Ingredient("cutstone", 4), Ingredient("goldenpickaxe", 1)}, RECIPETABS.WATER, TECH.NONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_water_well.xml")


AddRecipe("des_well_rack", {Ingredient("boards", 3), Ingredient("rope", 2), Ingredient("transistor", 1)}, RECIPETABS.WATER, TECH.NONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_well_rack_craft.xml", "des_well_rack_craft.tex")
--]]


-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000
-----------57887856856887656767876787676567876787800000000000000000000000000


--[[

AddRecipe("des_water_rack", {Ingredient("boards", 5), Ingredient("rope", 4), Ingredient("transistor", 2)}, RECIPETABS.WATER, TECH.NONE,
nil,nil,nil,nil,nil,
"images/inventoryimages/des_water_rack.xml")

--]]





--STRINGS.CHARACTERS.GENERIC.DESCRIBE.
--[[
--]]
local ChakraBadge = GLOBAL.require("widgets/thirstbadge")-- unneeded?

AddReplicableComponent("thirst")










-- FUNCTIONS TO RUN ON DEATH/RESPAWN --

local function RespawnChakra(ninja)
	if ninja.components.thirst ~= nil then
		ninja.components.thirst:Respawn()

	end
end

local function DeathChakra(ninja)
	if ninja.components.thirst ~= nil then
		ninja.components.thirst:Death()
	end
end

local function OnDeathSkeleton(inst)

end

local function OnChakraDirty(inst)
	if inst ~= nil then
		local current = inst.currentthirst:value()
		local max = inst.maxthirst:value()
		local penalty = inst.penaltythirst:value()
		if max < 200 and not inst:HasTag("clone") then
			max = 200
		end
		
		if inst.components.thirst.max ~= max then
			inst.components.thirst:SetMaxChakra(max)
		end
		
		if inst.components.thirst.penalty ~= penalty then
			inst.components.thirst:SetPenalty(penalty)
		end
		
		inst.components.thirst:SetCurrentChakra(current)
		
		inst:PushEvent("thirstdirty", {newpercent = current / max, current = current, max = max, penalty = penalty})
	end
end

--------------------

local function thirsteat(food,inst)
	if not inst.components.thirst then
		return
	end
--	local food=data.food
	local self=food.components.edible
	
	if inst:HasTag("player") then
		if food.components.cwater then
		elseif food.prefab=="icecream" or food.prefab=="berryshake" then
			inst.components.thirst:DoDelta(150)
		elseif food.prefab=="goatmilk" or food.prefab=="cookedmilk" or food.prefab=="cactus_flower" then
			inst.components.thirst:DoDelta(100)
		elseif food.prefab=="watermelon" or food.prefab=="cactus_meat" then
			inst.components.thirst:DoDelta(50)
		elseif food.prefab=="ice" or food.prefab=="rawmilk" then
			inst.components.thirst:DoDelta(25)
		elseif food.prefab=="hmato_item" then
			inst.components.thirst:DoDelta(20)
		elseif food.prefab=="lightbulb" or food.prefab=="berries_juicy" then
			inst.components.thirst:DoDelta(15)
		elseif self.foodtype=="VEGGIE" then
			inst.components.thirst:DoDelta(self.healthvalue*0.25+self.hungervalue*0.33)
		elseif self.foodtype=="MEAT" and food.components.dryable then
			inst.components.thirst:DoDelta(self.healthvalue*0.5+self.hungervalue*0.25)
		
		elseif (food.prefab=="meat_dried") or (food.prefab=="monstermeat_dried") or (food.prefab=="humanmeat_dried") then
			inst.components.thirst:DoDelta(-15)
		elseif (food.prefab=="smallmeat_dried") then
			inst.components.thirst:DoDelta(-8)
	
		
		end
	end
end

local function BurnableComponentPostInit(self)
  local oldCanEat = self.CanEat
  local oldOneaten = self.OnEaten
  
  self.OnEaten = function(self, eater)
		thirsteat(self.inst,eater)
		oldOneaten(self, eater)
  end
  --[[
  self.CanEat = function(self, inst)
	if (not self.inst:HasTag("player")) and inst:HasTag("bottle") then return false end
		oldCanEat(self, inst)
  end--]]
end

AddComponentPostInit("edible", BurnableComponentPostInit)





local function BuilderINIT(self)
--[[
  local oldDoBuild = self.DoBuild
  
  self.DoBuild = function(self, recname, ...)
	if recname == "des_water_well" then
		local hole = FindEntity(self.inst, 3, function(guy) return (guy.prefab=="des_well_hole" and not guy.components.workable) end)
		
		if not hole then 
			self.inst:DoTaskInTime(1, function()
				self.inst.components.talker:Say("There is no point placing the well shaft here.")
			end)
			return
		end
	end
	
	oldDoBuild(self, recname, ...)
  end
--]]
	


  local oldCanBuild = self.CanBuild
  
  self.CanBuild = function(self, recname)
	local recipevalid = GetValidRecipe(recname)
    if recipevalid == nil then
        return false
	elseif recname == "des_water_well" then
		local hole = FindEntity(self.inst, 3, function(guy) return (guy.prefab=="des_well_hole" and not guy.components.workable) end)
		---local grave_hole = FindEntity(self.inst, 3, function(guy) return (guy.prefab=="des_well_hole" and not guy.components.workable) end)
		
		
		
		if not hole then 
		--	self.inst:DoTaskInTime(0.1, function()
		--		self.inst.components.talker:Say("There is no point placing the well shaft here.")
		--	end)
			return false
		end
	elseif recname == "des_well_rack" then
		local well = FindEntity(self.inst, 3, function(guy) return (guy.prefab=="des_water_well" and not guy:HasTag("well_rack")) end)
		if not well then 
		--	self.inst:DoTaskInTime(0.1, function()
		--		self.inst.components.talker:Say("There is no point placing the well shaft here.")
		--	end)
			return false
		end
	end
	
	return oldCanBuild(self, recname)
  end


end

AddComponentPostInit("builder", BuilderINIT)









local function fakeRTCthirst(player)
	if not player.components.thirst then
		return
	end
	
	---if (not player.components.thirst) or (not player.components.temperature) or player:HasTag("playerghost") then return end
	local temp = player.components.temperature.current

		--player.components.thirst.current_temperature = player.components.temperature.current
		--player.components.thirst:SetThirstTemperature(player.components.temperature.current)
		
		if temp > TUNING.THRIST_SWEATSTART_MIN_TEMPERATURE and player.components.thirst.current > 1 then
			player.components.temperature:DoDelta(-0.1)
			--player.components.moisture:DoDelta(2)
			player.components.thirst:DoDelta(-0.5)
		end
		
		if temp > (TUNING.THRIST_SWEATSTART_MIN_TEMPERATURE + 10) and player.components.thirst.current > 1 then
			if player.components.moisture:GetMoisture()<0.4 then
				player.components.moisture:DoDelta(1.5)
			end
			
			player.components.thirst:DoDelta(-0.5)
			player.components.temperature:DoDelta(-0.1)
			if math.random()<0.5 then
				player.components.temperature:DoDelta(-0.1)
			end

		end
		
		
		if player.components.thirst.current<1 then   ------and player.replica.thirst.current <=0 then
			player.components.health:DoDelta(-0.5*TUNING.THIRST_DAMAGE_TUNE)----0.5)

		end
	
end






local function GiveChakra(inst)
--[[
	if not KnownModIndex:IsModEnabled("workshop-635360350") then
		inst:ListenForEvent("death", OnDeathSkeleton)
	end--]]

	if inst.components.thirst == nil then
		inst:AddComponent("thirst")
		inst.components.thirst:StartCharge(-TUNING.THIRST_DIFFILCULTY_THIRST_SPEED, 3)
		inst:ListenForEvent("death", DeathChakra)
		inst:ListenForEvent("respawnfromghost", RespawnChakra)
		
		inst.maxthirst = GLOBAL.net_ushortint( inst.GUID, "thirstmax", "currentdirty")
		inst.currentthirst = GLOBAL.net_ushortint( inst.GUID, "thirstcurrent", "currentdirty")
		inst.penaltythirst = GLOBAL.net_float( inst.GUID, "thirstpenalty", "currentdirty")
		
		if not TheWorld.ismastersim then
			inst:ListenForEvent("currentdirty", function(inst) OnChakraDirty(inst) end)
		end
		--
		
		
	
	end
	
	--if inst.components.thirst then
			--inst:DoPeriodicTask(1, function(inst) 
		--	inst.components.thirst:DoDelta(0)--Badge Updates
			--fakeRTCthirst(inst)
	--	end)	
	--end
	
	--inst:ListenForEvent("oneatsomething", thirsteat)
end



----------------------------------------------------------------
GLOBAL.TUNING.MODNAME_THIRST = "thirst"

AddModRPCHandler(GLOBAL.TUNING.MODNAME_THIRST, "thrist_current_temperature", function(player)
	local temp = player.components.temperature.current
	if player.components.health:IsDead() or player:HasTag("playerghost") then return end

	if player.components.thirst then
		
		--player.components.thirst.current_temperature = player.components.temperature.current
		--player.components.thirst:SetThirstTemperature(player.components.temperature.current)
		
		if temp > TUNING.THRIST_SWEATSTART_MIN_TEMPERATURE and player.components.thirst.current > 1 then
			player.components.temperature:DoDelta(-1)
			player.components.thirst:DoDelta(-0.5)
		end
		
		if temp > TUNING.THRIST_SWEATSTART_MIN_TEMPERATURE + 10 and player.components.thirst.current > 1 then
			player.components.moisture:DoDelta(1)
			player.components.thirst:DoDelta(-0.5)
		end
		
		
		if player.components.thirst:IsExhausted() then   ------and player.replica.thirst.current <=0 then
			player.components.health:DoDelta(-0.5*TUNING.THIRST_DAMAGE_TUNE)----0.5)
		end
	end
	
end)





-- RUNS THE ABOVE FUNCTION FOR ALL CHARACTERS, INCLUDING MODDED ONES --

--AddPlayerPostInit(GiveChakra)

local function FindOceanWaterRoG(inst, dist, atm, theta_delta)
	local attemp = atm or 0
    local dst = dist or 4
	local radius = dst
	--local angel_delta = theta_delta or PI
	local theta = theta_delta or math.random()*2*PI
	local offset = Vector3(radius * math.cos( theta ), 0, -radius * math.sin( theta ) )
	local pt = Vector3(inst.Transform:GetWorldPosition()) + offset  
	
	
	if pt and TheWorld.Map:GetTileAtPoint(pt:Get()) == GROUND.IMPASSABLE then
		return pt
    elseif attemp<20 then
		if theta_delta then
			FindOceanWaterRoG(inst, dst+0.75, attemp+1)
		else
			FindOceanWaterRoG(inst, dst+0.75, attemp+1, theta+PI)			
		end
	else
		return
	end
	
end









AddPlayerPostInit(function(inst)
	
		if inst.prefab == "wx78" then
			inst:AddTag("wx78_special_tablets")
		end
	
		inst:AddComponent("thirst")
		inst.components.thirst:StartCharge(-TUNING.THIRST_DIFFILCULTY_THIRST_SPEED, 3)
		inst:ListenForEvent("death", DeathChakra)
		inst:ListenForEvent("respawnfromghost", RespawnChakra)
		
		inst.maxthirst = GLOBAL.net_ushortint( inst.GUID, "thirstmax", "currentdirty")
		inst.currentthirst = GLOBAL.net_ushortint( inst.GUID, "thirstcurrent", "currentdirty")
		inst.penaltythirst = GLOBAL.net_float( inst.GUID, "thirstpenalty", "currentdirty")
		
		---water stream wetness effects---
		--inst:DoPeriodicTask(1, function(inst) 
			
			
		--end)
		----------------------------------
		
		
		if not TheWorld.ismastersim then
			inst:ListenForEvent("currentdirty", function(inst) OnChakraDirty(inst) end)
			

			inst:DoPeriodicTask(1, function(inst) 
				inst.components.thirst:DoDelta(0)--Badge Updates
			end)
		else
		
			---water stream wetness---
			inst:AddComponent("des_carefulwalker_water")
			--------------------------
			
			inst:DoPeriodicTask(1, function(inst) 
				inst.components.thirst:DoDelta(0)--Badge Updates
				----Because reasons---
				inst.fili_thirst = 100
				----------------------
				fakeRTCthirst(inst)
			end)
			-----SOME TRICKY SHIT FOR OCEAN WATER
			inst:DoPeriodicTask(3, function(inst) 
				if TUNING.THIRST_ALWAYS_SHOW_OCEAN == true then
					inst.saved_ocean_offest = true
					inst:AddTag("saved_ocean_offest")
				else

					local wants_to_fill = nil
					local ocean_offest = FindOceanWaterRoG(inst,4,10)
					
					if ocean_offest then
						inst.saved_ocean_offest = ocean_offest
					elseif math.random() < 0.25 then
						inst.saved_ocean_offest = nil
					end
					
					
					
					wants_to_fill = inst.components.inventory
							and inst.components.inventory:GetActiveItem()
							and inst.components.inventory:GetActiveItem().components.cwater
							and inst.components.inventory:GetActiveItem().components.cwater.current<1
					
					
					if wants_to_fill and not inst.saved_ocean_offest then

							------player is trying to get ocean water ! try harder to find it!
							local ocean_offest1 = FindOceanWaterRoG(inst,3,-10)
							if ocean_offest1 then
								inst.saved_ocean_offest = ocean_offest1
							end
							
					end
					if inst.saved_ocean_offest ~= nil then
						inst:AddTag("saved_ocean_offest")
					else
						inst:RemoveTag("saved_ocean_offest")
					
					end
				end	
					
					
					
					--[[
					if not inst.saved_ocean_offest then
						if 
						then
							------player is trying to get ocean water ! try harder to find it!
							local ocean_offest1 = FindOceanWaterRoG(inst,3,-10)
							if ocean_offest1 then
								inst.saved_ocean_offest = ocean_offest1
							end
							
						elseif math.random() < 0.5 then
							inst.saved_ocean_offest = nil
						end
					end--]]
					
				
			end)	
	end

	

end)



local function AddWaterContValid(inst)
	inst:AddTag("des_well_valid")
end


---idle  bottleswglass
local function OnDroppedMonsterMeat(inst)
	local pond = FindEntity(inst, 4, function(guy) return guy:HasTag("water_sourse_poisonable") end)
	if pond then
		pond.components.des_easy_code:AddTabletOrPoisoner(pond, inst, nil)
	end
end

local function AddWaterPoisoner(inst)
	inst:DoTaskInTime(3, function()
		if inst.components.inventoryitem then
			if not inst.components.inventoryitem:GetGrandOwner() then
			
				inst:AddTag("des_water_poisoner")
				inst:AddComponent("des_throw_in")
		
				inst.components.inventoryitem:SetOnDroppedFn(OnDroppedMonsterMeat)

				OnDroppedMonsterMeat(inst)
			end 
		end
	end)
end
AddPrefabPostInit("monstermeat", AddWaterContValid)
AddPrefabPostInit("monstermeat_dried", AddWaterContValid)
AddPrefabPostInit("monstermeat_cooked", AddWaterContValid)
AddPrefabPostInit("cutstone", AddWaterContValid)

AddPrefabPostInit("monstermeat", AddWaterPoisoner)
AddPrefabPostInit("monstermeat_dried", AddWaterPoisoner)
AddPrefabPostInit("monstermeat_cooked", AddWaterPoisoner)

-------------------------------------------------
---------------- POST GENERATION RETARDED WAY
-------------------------------------------------

local function findfountain_spawnpoint(caster)
    local ground = TheWorld
    local centers = {}
    for i, node in ipairs(ground.topology.nodes) do
        if ground.Map:IsPassableAtPoint(node.x, 0, node.y) then
            table.insert(centers, {x = node.x, z = node.y})
        end
    end
    if #centers > 0 then
        local pos = centers[math.random(#centers)]
        return pos.x, 0, pos.z
    else
        return caster:GetPosition()
    end
end


local function OnInitPostGen(inst)
		print("=========POST GEN!!!!!!!!!!!!! =  ")
		print("=========POST GEN!!!!!!!!!!!!! =  ")
		print("=========POST GEN!!!!!!!!!!!!! =  ")

		local ammount_of_holes = c_countprefabs("des_well_hole", true)
		local ammount_of_wells = c_countprefabs("des_water_well", true)
		local ammount_of_fountains = c_countprefabs("des_statue_charlie", true)
		local fountain = c_find("des_statue_charlie", nil, inst)
		-----local replacelist = {"evergreen", "rock1", "rock2", "rock_flintless","grass","evergreen", "rock1", "rock2", "rock_flintless","grass"}


		if (ammount_of_holes+ammount_of_wells) < TUNING.DES_THIRST_WATER_HOLES_MAX then
			print("=========No holes/wells GO FOR POST GEN=======")
			
			local x1, y1, z1 = findfountain_spawnpoint(inst)
			local des_well_hole = SpawnPrefab("des_well_hole")
			des_well_hole.Transform:SetPosition(x1, 0, z1)
			
			--[[
			local evergreen = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, inst)
			
			local evergreen = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, inst)
			if not evergreen then evergreen = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, inst) end 
			if not evergreen then evergreen = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, inst) end 
			if not evergreen then evergreen = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, inst) end 
			if not evergreen then evergreen = c_find("evergreen2", nil, inst) end 

			if evergreen then
				local new_des_well_hole = SpawnPrefab("des_well_hole")
				new_des_well_hole.Transform:SetPosition(evergreen.Transform:GetWorldPosition())
				evergreen:Remove()
			end
			--]]
			---- it will spawn other holes by itself
		end
		
	
		if (ammount_of_fountains == 0) and (TUNING.DES_THIRST_ALLOW_FOUNTAIN==true) then
			local x2, y2, z2 = findfountain_spawnpoint(inst)
			local new_des_fountain = SpawnPrefab("des_statue_charlie")
			new_des_fountain.Transform:SetPosition(x2, 0, z2)
	
		--[[if ((ammount_of_fountains == 0) or (not fountain)) and (TUNING.DES_THIRST_ALLOW_FOUNTAIN==true) then
			print("=========No FOUNTAIN GO FOR POST GEN=======")
			local des_speical_dummy = SpawnPrefab("des_speical_dummy")
			des_speical_dummy.Transform:SetPosition(0,0,0)
			
			local evergreen2 = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, des_speical_dummy)
			if not evergreen2 then evergreen2 = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, des_speical_dummy) end 
			if not evergreen2 then evergreen2 = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, des_speical_dummy) end 
			if not evergreen2 then evergreen2 = c_find(replacelist[math.ceil(math.random(1,#replacelist))], nil, des_speical_dummy) end 
			if not evergreen2 then evergreen2 = c_find("evergreen", nil, des_speical_dummy) end 

			
			if evergreen2 then
				local new_des_fountain = 
				new_des_fountain.Transform:SetPosition(evergreen2.Transform:GetWorldPosition())
				evergreen2:Remove()
			end--]]
		end

end


local function OnInitPostGenInit(prefab)
	local inst=prefab

	
	inst:DoTaskInTime(1, OnInitPostGen)


end
--AddPrefabPostInit("critterlab", OnInitPostGenInit)
--AddPrefabPostInit("forest", OnInitPostGenInit)

---




-------------------------------------------------
----------------------------------
-------------------------------------------------











--------------------------------------------------
------------------- WIDGETS
--------------------------------------------------

modimport("thirst_widgets")

--------------------------------------------------
---------------------------------
--------------------------------------------------




--------------------------------------------------
------------------- CHAI RECIPES
--------------------------------------------------

modimport("thirst_chai_recipes")

--------------------------------------------------
---------------------------------
--------------------------------------------------



--------------------------------------------------
------------------- INVENTORY SLOTS
--------------------------------------------------

modimport("thirst_invslots_show")



--------------------------------------------------
------------------- POND MOD
--------------------------------------------------

modimport("thirst_water_sources")

--------------------------------------------------
---------------------------------
modimport("thirst_breakage")


--------------------------------------------------
------------------- PREFAB UPDATES
--------------------------------------------------

modimport("thirst_prefabs_updates")




--------------------------------------------------
------------------- FIRE FIGHTER
--------------------------------------------------

modimport("thirst_firefighter_update")

--------------------------------------------------
---------------------------------
--------------------------------------------------


---------Some easter eggs
local function Trinket_26INIT(prefab)
	prefab:DoTaskInTime(1, function()
		SpawnPrefab("des_potato_cup").Transform:SetPosition(prefab.Transform:GetWorldPosition())
		prefab:Remove()
	end)


end


AddPrefabPostInit("trinket_26", Trinket_26INIT)










--------------------------------------------------
------------------- POST GEN
--------------------------------------------------
local function onfinishcallback(inst, worker)
	inst.des_oldCallBack(inst, worker)
	

	
	if inst then
		if math.random() < TUNING.THIRST_REPLACE_GRAVES_CHANCE then
			local hole = SpawnPrefab("des_well_hole")
			hole.Transform:SetPosition(inst.Transform:GetWorldPosition())
			
			if worker then
				hole.components.workable:Destroy(worker)
			end
			inst:Remove()
		end
	elseif inst then
		if math.random() < TUNING.THIRST_REPLACE_GRAVES_RIVERS_CHANCE then
			local hole = SpawnPrefab("des_river_owner")
			hole.Transform:SetPosition(inst.Transform:GetWorldPosition())
			
			if worker then
				hole.components.workable:Destroy(worker)
			end
			inst:Remove()
		end
	end	
end


local function MoundInit(inst)
	if (TUNING.THIRST_REPLACE_GRAVES_CHANCE > 0 or TUNING.THIRST_REPLACE_GRAVES_RIVERS_CHANCE > 0) and inst.components.workable then
		inst.des_oldCallBack = inst.components.workable.onfinish
		inst.components.workable:SetOnFinishCallback(onfinishcallback)
	end
end

AddPrefabPostInit("mound", MoundInit)

------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
local function onfinishcallback(inst, worker)
	inst.des_oldCallBack(inst, worker)
	
	if inst then
			local x, y, z = inst.Transform:GetWorldPosition()
			local statue = SpawnPrefab("des_statue_charlie")
			statue.Transform:SetPosition(x+4, y, z-4)
			--local knight = inst.replacer
			--knight.Transform:SetPosition(worker.Transform:GetWorldPosition())

			---inst:Remove()
	end
end

local function FiguKnight(inst)
	if inst.components.workable then
		inst.des_oldCallBack = inst.components.workable.onfinish
		inst.replacer = "knight"
		inst.components.workable:SetOnFinishCallback(onfinishcallback)
	end
end
local function FiguRook(inst)
	if inst.components.workable then
		inst.des_oldCallBack = inst.components.workable.onfinish
		inst.replacer = "rook"
		inst.components.workable:SetOnFinishCallback(onfinishcallback)
	end
end
local function FiguBishop(inst)
	if inst.components.workable then
		inst.des_oldCallBack = inst.components.workable.onfinish
		inst.replacer = "bishop"
		inst.components.workable:SetOnFinishCallback(onfinishcallback)
	end
end
--AddPrefabPostInit("sculpture_knightbody", MoundInit)
if TUNING.THIRST_REPLACE_MARBLE_KNIGHT then
	AddPrefabPostInit("sculpture_knightbody", FiguKnight)
end
if TUNING.THIRST_REPLACE_MARBLE_ROOK then
	AddPrefabPostInit("sculpture_rookbody", FiguRook)
end
if TUNING.THIRST_REPLACE_MARBLE_BISHOP then
	AddPrefabPostInit("sculpture_bishopbody", FiguBishop)
end
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------

------------CACTUS FIX---------------

local function onpickedfnCactus(inst, picker)
	inst.des_oldPick(inst, picker)
	if picker and math.random() < TUNING.DES_SNAKE_SPAWN_CACTUS_CHANCE then
		local des_water_snake = SpawnPrefab("des_water_snake")
		des_water_snake.Transform:SetPosition(picker.Transform:GetWorldPosition())
	end
end


local function CactusFix(inst)
	if inst.components.pickable then
		inst.des_oldPick = inst.components.pickable.onpickedfn
		inst.components.pickable.onpickedfn = onpickedfnCactus
	end
end
AddPrefabPostInit("cactus", CactusFix)
-------------------------------------
--]]


--]]
--statueglommer

--[[
local function Trinket_26INIT(prefab)
	prefab:DoTaskInTime(1, function()
		SpawnPrefab("des_potato_cup").Transform:SetPosition(prefab.Transform:GetWorldPosition())
		prefab:Remove()
	end)


end


AddPrefabPostInit("trinket_26", Trinket_26INIT)--]]


