local des_throw_in = Class(function(self, inst)
    self.inst = inst
end)


----- Use X items from stack, drop unused items ----
function des_throw_in:UseAndDrop(ammount, maximum, bucket, player, owner)
	local inst = owner or self.inst
	if not inst.components.container then
		return
	end
	local removeflag = nil

		local stacksz = bucket.components.stackable.stacksize
		local touse = ammount	
		if touse > maximum then
			touse = maximum
		end
		stacksz = stacksz - touse
		if (stacksz <= 0) or (bucket.components.stackable.stacksize==1) then
			removeflag = true
			stacksz = 1
		end		
		
		inst.components.container:Close()
		--inst.components.container:ConsumeByName(bucket.prefab, touse)
		bucket.components.stackable:SetStackSize(stacksz)
		if removeflag and bucket then
			bucket:Remove()
		elseif bucket then
			inst.components.container:DropItem(bucket)
			if player then
				player.sg:GoToState("give")
				player.components.inventory:GiveItem(bucket, nil, nil, true)
			end
		end
		
		
		
		return touse
end


----- Place X items from stack, drop unused items ----
function des_throw_in:ThrowToSlot(tablet, target, ammount, player, slot)
	if not target.components.cwater then return end

	if not ammount then
		ammount = math.ceil(target.components.cwater.current / TUNING.THIRST_DEFAULT_SIP_SIZE)
	end
	local stacksz = 1

	if tablet.components.stackable then stacksz = tablet.components.stackable.stacksize end
	if ammount > stacksz then ammount = stacksz end
	
	tablet:AddTag("des_thirst_item_forced_place")
	--local name = tablet.name
	
	if tablet then
		tablet:DoTaskInTime(0.05, function()
			print("TABLET DROPPED")
			player.components.inventory:DropItem(tablet, true)
		end)
		
		tablet:DoTaskInTime(0.1, function()
			print("TABLET PUT INTO KETTLE")
			target.components.container:GiveItem(tablet, slot, nil, true)
			tablet:RemoveTag("des_thirst_item_forced_place")
		end)
	end
	return true
end

return des_throw_in