local assets =
{
    Asset("ANIM", "anim/aquagem.zip"),
	Asset("ATLAS", "images/inventoryimages/des_waterdrop_fake.xml"), -------bottle_moonrock
	Asset("ATLAS", "images/inventoryimages/des_waterdrop_fake_empty.xml"), -------bottle_moonrock
	
	Asset("ATLAS", "images/inventoryimages/des_waterdrop_fake_chai.xml"), -------bottle_moonrock

	Asset("ATLAS", "images/inventoryimages/des_chainik_empty_act.xml"), -------bottle_moonrock
	
	
	Asset("ATLAS", "images/inventoryimages/des_samovar_ico_flame.xml"), -------bottle_moonrock
	Asset("ATLAS", "images/inventoryimages/des_samovar_ico_off.xml"), -------bottle_moonrock
	
}


--[[
local function PutToItsPlace(inst)
	--if inst.components.inventoryitem.owner and inst.components.inventoryitem.owner.components.inventory then
	--	inst.components.inventoryitem.owner.components.inventory:DropItem(inst)
	--end
	
	--inst.original_owner.components.container:GiveItem(inst)
	
end

local function SetOnPickupFn(inst)

    inst:DoTaskInTime(.25, function ( inst )
		if inst.components.inventoryitem.owner and inst.components.inventoryitem.owner.components.inventory then
			inst.components.inventoryitem.owner.components.inventory:DropItem(inst, true)
		
			if inst.original_owner then
				inst.original_owner.components.container:GiveItem(inst)
			end
		end
	end)
end

local function SetOnActiveItemFn(inst)
	
end
--]]


-- local function OnDropped(inst)
-- --print("REMOVE FAKE DROP")
	-- --inst:Remove()
	-- if inst.original_owner then
		-- inst.original_owner.components.container:GiveItem(inst)
	-- end
-- end


local function OnPickupEmpty(inst, owner)
	print("------------------------------")
	print("OnPickupEmpty DES_CHAINIK_EMPTY_ACT")
	if owner:HasTag("player") and inst.original_owner and inst.original_owner.components.cwater and inst.original_owner.components.cwater.current>0 then
		print("GroundPour")
		print("Close")
		print("------------------------------")
		if inst.original_owner.components.des_chainik_c and inst.original_owner.components.des_chainik_c.boiling then
			local word = TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS[math.random(#TUNING.THIRST_TRANSFUSE_CHAINIK_BOILS)]
			
			if owner then
				owner.components.talker:Say(word)
			end
		
		else
		
			inst.original_owner.components.cwater:GroundPour(nil, nil, 10000)
			inst.original_owner.components.container:Close()
			inst:DoTaskInTime(0, function()
				inst.original_owner.components.cwater:EmptyBottle()
				inst.original_owner.components.container:Open(owner)
				inst:Remove()
			end)
		end

	end
end
local function OnDropped(inst)
	inst:DoTaskInTime(0, function()
		inst:Remove()
	end)
end




local function OnPickupFlame(inst, owner)
	print("------------------------------")
	print("OnPickupFlame Flame")
	if owner:HasTag("player") and inst.original_owner and inst.original_owner.components.des_chainik_c.boiling then
		print("EXTINGUISH")
		inst.original_owner.components.des_chainik_c:TryToFinishBrewing()
		print("Close")
		print("------------------------------")


		inst.original_owner.components.container:Close()
		inst:DoTaskInTime(0, function()
			inst.original_owner.components.container:Open(owner)
			inst:Remove()
		end)
	end
end

local function OnPickupOff(inst, owner)
	print("------------------------------")
	print("OnPickupOff Off")
	if owner:HasTag("player") and inst.original_owner and not inst.original_owner.components.des_chainik_c.boiling then
		print("BOIL")
		inst.original_owner.components.des_chainik_c:StartBoil()
		print("Close")
		print("------------------------------")


		inst.original_owner.components.container:Close()
		inst:DoTaskInTime(0, function()
			inst.original_owner.components.container:Open(owner)
			inst:Remove()
		end)
	end
end


local function buildgem(colour)


    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddNetwork()

        MakeInventoryPhysics(inst)

      --  inst.AnimState:SetBank("aquagem")
      --  inst.AnimState:SetBuild("aquagem")
       
	   
	    inst:AddTag("des_water_container_valid")
		inst:AddTag("heavy")
		----inst:AddTag("irreplaceable")
	   
	   
	   
	   
		inst.persists = false

	   inst.AnimState:PlayAnimation("gem_idle", true)

       -- inst:AddTag("molebait")
       -- inst:AddTag("quakedebris")

        inst.entity:SetPristine()
		
		--local s = 2.2	
		--inst.Transform:SetScale(s,s,s )
		
        if not TheWorld.ismastersim then
            return inst
        end


		if colour == "des_waterdrop_fake" then
			inst:AddComponent("stackable")
			----inst.components.stackable.stacksize = 1
			inst.components.stackable.maxsize = 40
		end
		
        inst:AddComponent("inspectable")
        inst:AddComponent("named")

        inst:AddComponent("inventoryitem")
		inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
		
		if colour == "des_waterdrop_fake" then
			inst:AddComponent("des_drink")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/des_waterdrop_fake.xml"
		elseif colour == "des_waterdrop_fake_chai" then
			inst:AddComponent("des_drink")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/des_waterdrop_fake_chai.xml"
		elseif colour == "des_chainik_empty_act" then
			inst.components.inventoryitem:SetOnPickupFn(OnPickupEmpty)
			inst.components.inventoryitem:SetOnDroppedFn(OnDropped)
			inst.components.named:SetName("清空")
			inst.components.inspectable:SetDescription("把所有东西都倒在地上")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/des_chainik_empty_act.xml"
			
		elseif colour == "des_samovar_ico_flame" then
			inst.components.inventoryitem:SetOnPickupFn(OnPickupFlame)
			inst.components.named:SetName("关火!")
			inst.components.inspectable:SetDescription("关火!")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/des_samovar_ico_flame.xml"
		elseif colour == "des_samovar_ico_off" then
			inst.components.inventoryitem:SetOnPickupFn(OnPickupOff)
			inst.components.named:SetName("开火!")
			inst.components.inspectable:SetDescription("开火!")
			inst.components.inventoryitem.atlasname = "images/inventoryimages/des_samovar_ico_off.xml"		
		end
		--inst.components.inventoryitem:SetOnPickupFn(SetOnPickupFn)
	--	inst.components.inventoryitem:SetOnPutInInventoryFn(SetOnPickupFn)
		
		--inst:DoPeriodicTask(10, function()
		--	if inst.components.inventoryitem and inst.components.inventoryitem.owner and inst.components.inventoryitem.owner:HasTag("player") then
		--		inst:Remove()
		--	end
		--end)
				---figure out icon needed---
		---"COOKING NOW"-->EXTINGUISH
		---"OFF NOW"-->BOIL

		
		
		
        return inst
    end
    return Prefab(colour, fn, assets)
end

return buildgem("des_waterdrop_fake"),
buildgem("des_waterdrop_fake_chai"),
buildgem("des_chainik_empty_act"),
buildgem("des_samovar_ico_flame"),
buildgem("des_samovar_ico_off")

