
------------------------------------------------------
-------------------- INVENTORY SLOTS -----------------
------------------------------------------------------

local seg_time = 30
local total_day_time = seg_time*16
local FIRESUPPRESSOR_MAX_FUEL_TIME = total_day_time*5
local MED_FUEL = seg_time * 1.5 ---- one log

_G = GLOBAL
local Ingredient = GLOBAL.Ingredient
local RECIPETABS = GLOBAL.RECIPETABS
local STRINGS = GLOBAL.STRINGS
local TECH = GLOBAL.TECH



local UIAnim = require "widgets/uianim"

local Image = GLOBAL.require "widgets/image"
local function TileThawPostInit(self, invitem)
	self.thaw_bg = self:AddChild(Image())
	self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
	self.thaw_bg:Hide()
	self.thaw_bg:SetClickable(false)
	self.thaw_basescale = 1
	if self.thaw_bg then
        self.thaw_bg:MoveToBack()--Index - bg: 0, modified: 1, spoilage: 2
    end--so ordering is perish_bg, modifier, perish_pct, wetness, recharge_bg, item, recharge_pct
	
	if self.bg then
        self.bg:MoveToBack()--Index - bg: 0, modified: 1, spoilage: 2
    end--so ordering is perish_bg, modifier, perish_pct, wetness, recharge_bg, item, recharge_pct

	if invitem:HasTag("cwater_icon") then
		self.thaw_bg:Hide()
		---fooling itemtile widget---
		self:StartUpdating()
		self.rechargepct = 0
		self.rechargetime = 99999999
		self.rechargeframe = self:AddChild(UIAnim())
		self.recharge = self:AddChild(UIAnim())
		-----------------------------
		if invitem:HasTag("des_cwater_full") then
			self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_full.xml", "des_cwater_full.tex")
		elseif invitem:HasTag("des_cwater_third") then
			self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_third.xml", "des_cwater_third.tex")
		elseif invitem:HasTag("des_cwater_half") then
			self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_half.xml", "des_cwater_half.tex")
		elseif invitem:HasTag("des_cwater_quoter") then
			self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_quoter.xml", "des_cwater_quoter.tex")
		elseif invitem:HasTag("des_cwater_empty") then
			self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
		end
		
		self.thaw_bg:Show()
	end
end
AddClassPostConstruct("widgets/itemtile", TileThawPostInit)










local ItemTile = require "widgets/itemtile"

AddGlobalClassPostConstruct("widgets/inventorybar", "ItemTile", function()
    local ItemTile_Refresh_base = ItemTile.Refresh or function() return "" end
    local ItemTile_UpdateTooltip_base = ItemTile.UpdateTooltip or function() return "" end
    --local ItemTile_OnUpdate_base = ItemTile.OnUpdate or function() return "" end
    local ItemTile_SetChargePercent_base = ItemTile.SetChargePercent or function() return "" end
	
	
	---local Inv_Rebuild_base = Inv.Rebuild or function() return "" end

	
	
	
    function ItemTile:Refresh()
		local invitem = self.item
		if invitem:HasTag("cwater_icon") and self.thaw_bg then
			self:StartUpdating()
			self.thaw_bg:Hide()
			self.rechargetime = 99999999
			if invitem:HasTag("des_cwater_full") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_full.xml", "des_cwater_full.tex")
			elseif invitem:HasTag("des_cwater_third") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_third.xml", "des_cwater_third.tex")
			elseif invitem:HasTag("des_cwater_half") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_half.xml", "des_cwater_half.tex")
			elseif invitem:HasTag("des_cwater_quoter") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_quoter.xml", "des_cwater_quoter.tex")
			elseif invitem:HasTag("des_cwater_empty") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
			end
			
			self.thaw_bg:Show()
		end

        ItemTile_Refresh_base(self)
    end

	
	
	
    function ItemTile:UpdateTooltip()
		local invitem = self.item
		if invitem:HasTag("cwater_icon") and self.thaw_bg then
			self.thaw_bg:Hide()
			self.rechargetime = 99999999
			self:StartUpdating()
			if invitem:HasTag("des_cwater_full") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_full.xml", "des_cwater_full.tex")
			elseif invitem:HasTag("des_cwater_third") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_third.xml", "des_cwater_third.tex")
			elseif invitem:HasTag("des_cwater_half") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_half.xml", "des_cwater_half.tex")
			elseif invitem:HasTag("des_cwater_quoter") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_quoter.xml", "des_cwater_quoter.tex")
			elseif invitem:HasTag("des_cwater_empty") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
			end
			
			self.thaw_bg:Show()
		end

        ItemTile_UpdateTooltip_base(self)
    end	

	
    function ItemTile:SetChargePercent(percent)
		local invitem = self.item
		if invitem:HasTag("cwater_icon") and self.thaw_bg then
			self.thaw_bg:Hide()
			self:StartUpdating()
			self.rechargetime = 99999999
			if invitem:HasTag("des_cwater_full") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_full.xml", "des_cwater_full.tex")
			elseif invitem:HasTag("des_cwater_third") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_third.xml", "des_cwater_third.tex")
			elseif invitem:HasTag("des_cwater_half") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_half.xml", "des_cwater_half.tex")
			elseif invitem:HasTag("des_cwater_quoter") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_quoter.xml", "des_cwater_quoter.tex")
			elseif invitem:HasTag("des_cwater_empty") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
			end
			
			self.thaw_bg:Show()
		end

        ItemTile_SetChargePercent_base(self, percent)
    end	
	
	--[[
	function ItemTile:OnUpdate(dt)
		local invitem = self.item
		if invitem:HasTag("cwater_icon") and self.thaw_bg then
			self.thaw_bg:Hide()

			if invitem:HasTag("des_cwater_full") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_full.xml", "des_cwater_full.tex")
			elseif invitem:HasTag("des_cwater_third") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_third.xml", "des_cwater_third.tex")
			elseif invitem:HasTag("des_cwater_half") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_half.xml", "des_cwater_half.tex")
			elseif invitem:HasTag("des_cwater_quoter") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_quoter.xml", "des_cwater_quoter.tex")
			elseif invitem:HasTag("des_cwater_empty") then
				self.thaw_bg:SetTexture("images/inventoryimages/des_cwater_empty.xml", "des_cwater_empty.tex")
			end
			
			self.thaw_bg:Show()
		end

        ItemTile_OnUpdate_base(self)
    end--]]
	
	
	
end)



