------------------------------------------------------
----------------------- WIDGET -----------------------
------------------------------------------------------
_G = GLOBAL
if GLOBAL.TUNING then local TUNING = GLOBAL.TUNING end
---------------------- function ----------------------
-- x+(Вправо)
-- x-(Влево)
-- y+(Вверх)
-- y-(Вниз)



local function widgetcreation()
	local params={}
	------WELL 1 SLOT-----
	params.des_water_well =
	{
		widget =
		{
			slotpos =
			{
				Vector3(0, 0, 0), 
			},
			animbank = "ui_cookpot_1x4",
			animbuild = "ui_cookpot_1x4",
			pos = _G.Vector3(0,190,0),
			side_align_tip = 160,
		},
	type = "chest",
	}
	function params.des_water_well.itemtestfn(container, item, slot)
		if item:HasTag("des_well_valid") or item:HasTag("des_bucket") or item:HasTag("fili_bucket") then
			return true
		end

		return false
	end
	
	------CATCHER 2 SLOTS-----
	params.watercatcher_grass = 
    {
        widget =
        {
			slotpos =
			{
				Vector3(-45, 120-40+6, 0),
				Vector3(-45, 4-70+6, 0), 
				--Vector3(0, -16, 0),
				--Vector3(0, -(32 + 4), 0), 
			},
			animbank = "des_ui_wcatcher1x2",
			animbuild = "des_ui_wcatcher1x2",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	function params.watercatcher_grass.itemtestfn(container, item, slot)
		if item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
			return true
		end

		return false
	end
	------Distilator 3 SLOTS-----
	params.waterdestcoal = 
    {
        widget =
        {
			slotpos =
			{
				Vector3(-45, 0.7*(64 + 32 + 8 + 4)+8+16, 0), 
				--Vector3(0, -16, 0),
				Vector3(-45, 0, 0), 
				Vector3(-45, -(64 + 32 + 8 + 4)*0.9, 0),
			},
			animbank = "des_ui_wcatcher1x3",
			animbuild = "des_ui_wcatcher1x3",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	function params.waterdestcoal.itemtestfn(container, item, slot)
		if item:HasTag("des_cleantablet") or item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
			return true
		end

		return false
	end

	------Barrel 3 SLOTS-----
	params.des_water_barrel = 
    {
        widget =
        {
			slotpos =
			{
				Vector3(-45, 0.7*(64 + 32 + 8 + 4)+8+16, 0), 
				--Vector3(0, -16, 0),
				Vector3(-45, 0, 0), 
				Vector3(-45, -(64 + 32 + 8 + 4)*0.9, 0),
			},
			animbank = "des_ui_wbarrel1x3",
			animbuild = "des_ui_wbarrel1x3",
			pos = Vector3(200, 0, 0),
			side_align_tip = 100,
        },
        type = "chest",
    }
	function params.des_water_barrel.itemtestfn(container, item, slot)
		if item:HasTag("des_cleantablet") or item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
			return true
		end

		return false
	end
	------------------------------
	------------CHAINIK-----------
	------------------------------
	
	params.des_chainik =
	{
		widget =
		{
			slotpos = {},
			animbank = "des_ui_chainik3x3",
			animbuild = "des_ui_chainik3x3",
			pos = Vector3(100, -150, 0),
			side_align_tip = 160,
		},
		type = "chest",
	}

	
	for y = 2, 0, -1 do
		local xstep = TUNING.DES_XSTEP
		local ystep = TUNING.DES_YSTEP
		local ysip = TUNING.DES_YSIP
		local ysp = TUNING.DES_YSP
		
		for x = 0, 2 do
			if y==1 then
			else
			table.insert(params.des_chainik.widget.slotpos, Vector3(75 * x - xstep * 2 + xstep, ysip * y - ystep * 2 + ystep + ysp, 0))
			end
		end
	end
	
	function params.des_chainik.itemtestfn(container, item, slot)
	
		if item:HasTag("des_chainik") then
			return false
		end
		
		if item:HasTag("des_thirst_item_forced_place") then return true end

		if (item.prefab == "des_waterdrop_fake" and slot == 1) or (item.prefab == "des_waterdrop_fake_chai" and slot == 3) or (item.prefab == "des_chainik_empty_act" and slot == 5) then
			return true
		elseif item:HasTag("des_zavarka") and slot == 2 then	
			return true
		elseif (item.components.cwater or item:HasTag("cwater")) and (slot == 4 or (slot == 6 and not item:HasTag("des_bucket"))) then	
			return true
			
		elseif (item:HasTag("kettlebrew")) and (slot == 2) then	
			return true
		
		
		--elseif item:HasTag("des_cleantablet") or item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
		--	return true
		end

		return 
	end	
	------------------------------
	------------SAMOVAR-----------
	------------------------------
	-- x+(Вправо)
	-- x-(Влево)
	-- y+(Вверх)
	-- y-(Вниз)

	params.des_samovar =
	{
		widget =
		{
			slotpos = {},
			animbank = "des_ui_samovar3x3",
			animbuild = "des_ui_samovar3x3",
			pos = Vector3(200,0, 0),
			side_align_tip = 160,
		},
		type = "chest",
	}

	-- TUNING.DES_XSTEP = 77
-- TUNING.DES_YSTEP = 160
-- TUNING.DES_YSIP = 80
-- TUNING.DES_YSP = 80

	for y = 2, -1, -1 do
		local xstep = 106
		local ystep = 72
		local x_start = 105-200-10
		local y_start = 85-112-12
		
		for x = 0, 2 do
			if y==1 then
			elseif y == -1 and x == 1 then
			table.insert(params.des_samovar.widget.slotpos, Vector3(xstep * x + x_start, ystep * y + y_start-1, 0))
			elseif y ~= 3 and y ~= -1 then
			table.insert(params.des_samovar.widget.slotpos, Vector3(xstep * x + x_start, ystep * y + y_start, 0))
			end
		end
	end	

	--------------------------
	--------------------------
	-- 1st slot always contains fake_drop
	-- 2nd slot can only contain zavarka
	-- 3rd слот всегда показывает, какой напиток внутри и сколько его
	-- 4 слот залить воды в чайник
	-- 5 слот готовить
	-- 6 слот позволяет набрать напиток
	-- 7 слот вылить
	--------------------------
	--------------------------

	function params.des_samovar.itemtestfn(container, item, slot)
	
		if item:HasTag("des_chainik") then
			return false
		end
		
		if item:HasTag("des_thirst_item_forced_place") then return true end
	
		if (item.prefab == "des_waterdrop_fake" and slot == 1) or (item.prefab == "des_waterdrop_fake_chai" and slot == 3)
		or (item.prefab == "des_chainik_empty_act" and slot == 7)
		or (item.prefab == "des_samovar_ico_flame" and slot == 5)
		or (item.prefab == "des_samovar_ico_off" and slot == 5)
		then
			return true
		elseif item:HasTag("des_zavarka") and slot == 2 then	
			return true
		elseif (item.components.cwater or item:HasTag("cwater")) and (slot == 4 or (slot == 6 and not item:HasTag("des_bucket"))) then	
			return true
			
		elseif (item:HasTag("kettlebrew")) and (slot == 2) then	
			return true
		
		
		--elseif item:HasTag("des_cleantablet") or item:HasTag("des_water_container_valid") or item:HasTag("des_bottle") or item:HasTag("des_bucket") then
		--	return true
		end

		return 
	end	
	------------------------------
	------------------------------
	------------------------------


	
	
	local containers = _G.require "containers"
	containers.MAXITEMSLOTS = math.max(containers.MAXITEMSLOTS, params.des_water_well.widget.slotpos ~= nil and #params.des_water_well.widget.slotpos or 0)

	local old_widgetsetup = containers.widgetsetup
	function containers.widgetsetup(container, prefab, data, ...)
		local pref = prefab or container.inst.prefab
		local name = pref 
		if container.inst:HasTag("des_transfuse_to_2nd_slot") then
			name = "watercatcher_grass"
		elseif name == "des_water_barrel" then
			name = "des_water_barrel"
		elseif container.inst:HasTag("water_dest_new") then
			name = "waterdestcoal"
		elseif pref == "des_enkettle" then
			name = "des_samovar"
		end
		if name == "des_samovar" or name == "des_water_well" or name == "watercatcher_grass" or name=="waterdestcoal" or name == "des_chainik" or name == "des_water_barrel" then
			local t = params[name]
			if t ~= nil then
				for k, v in pairs(t) do
					container[k] = v
				end
			container:SetNumSlots(container.widget.slotpos ~= nil and #container.widget.slotpos or 0)
			end
		else
			return old_widgetsetup(container, prefab, data, ...)
		end
	end
end


---------------------- call function ----------------------
widgetcreation()

---------------------------------------------------