GLOBAL.require("map/terrain")

--Upper text is not used
local function mymathclamp(num, min, max)
    return num <= min and min or (num >= max and max or num)
end
local function myround(num, idp)
    return GLOBAL.tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

local function AddThingtoWorldGeneration(prefab,roomincrease)
    local Increase = 0
    for roomstr,add in pairs(roomincrease) do
        Increase = add/100
        if Increase > 0 and Increase <= 0.2 then
            local oldpercent = 0
            local oldsum = 0
            local prefabvalue = 0
            AddRoomPreInit(roomstr, -- if the room does not exist, it is added... so in case we want to support mod rooms, we shoudl call all active rooms first, and test if this room is active at the momentё
                function(room)
                    if room.contents then
                        oldpercent = room.contents.distributepercent or 0
                        if not room.contents.distributeprefabs or oldpercent==0 then
                            room.contents.distributeprefabs = {}
                            prefabvalue = 1 -- here this value does not matter, cause it is the only one
                            room.contents.distributeprefabs[prefab] = (room.contents.distributeprefabs[prefab] and room.contents.distributeprefabs[prefab] + prefabvalue) or prefabvalue
                            room.contents.distributepercent = Increase
                        else
                            oldsum = 0
                            for distprefab,number in pairs(room.contents.distributeprefabs) do
                                if type(number)=="table" then -- eg: smallmammal = {weight = 0.025, prefabs = {"rabbithole", "molehill"}},
                                    -- print("number ist eine table bei: "..tostring(distprefab).." in room: "..tostring(roomstr))
                                    for k,v in pairs(number) do
                                        -- print("k: "..tostring(k).." v: "..tostring(v))
                                        if type(v)=="number" and k=="weight" then
                                            oldsum = oldsum + v
                                        end
                                    end
                                elseif type(number)=="number" then
                                    oldsum = oldsum + number
                                end
                            end
                            room.contents.distributepercent = mymathclamp(oldpercent + Increase,0,1)
                            prefabvalue = myround((oldsum * (room.contents.distributepercent / oldpercent)) - oldsum,8)
                            room.contents.distributeprefabs[prefab] = (room.contents.distributeprefabs[prefab] and room.contents.distributeprefabs[prefab] + prefabvalue) or prefabvalue
                        end
                        -- print("Increaser Debug: "..roomstr..": added "..prefab..". oldpercent: "..oldpercent..", oldsum: "..oldsum..", newpercent: "..room.contents.distributepercent..", prefabvalue: "..prefabvalue..", newvalue: "..room.contents.distributeprefabs[prefab])
                    end
                end
            )
            print("Increaser: Add "..tostring(myround(Increase*100,2)).."% "..prefab.." to room: "..roomstr)
        elseif Increase > 0.2 then
            print("Increaser: Value of Increase is too high for "..prefab..", reduce it!")
        end
    end
end


local gen_hydromato=GetModConfigData("Hydromato gen")*2
local gen_holes=0.06
local gen_tea_trees=GetModConfigData("Tea tree gen")*1.5
local gen_tea_trees_cave = gen_tea_trees*2
local gen_tea_trees_bee = gen_tea_trees*2


local gen_ivan_chai=GetModConfigData("Ivan chai gen")
local gen_ivan_chai_cave=gen_ivan_chai*2
local gen_ivan_chai_bee =gen_ivan_chai*2



----AddThingtoWorldGeneration("hmato_planted",{BarePlain = gen_holes,BGSavanna = gen_holes, BGGrass=gen_holes, BurntForest=gen_holes, BurntForest=gen_holes, BGDeepForest=gen_holes, BGDeciduous=gen_holes,BGForest=gen_holes,BGCrappyFores=gen_holes})

AddThingtoWorldGeneration("hmato_planted",{BurntForest=gen_hydromato, BurntForest=gen_hydromato, BGDeepForest=gen_hydromato,BGForest=gen_hydromato,BGCrappyFores=gen_hydromato})
GLOBAL.terrain.filter.hmato_planted = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER}


AddThingtoWorldGeneration("des_ivan_chai_tree",{BarePlain = gen_ivan_chai,BGSavanna = gen_ivan_chai,
BGGrass=gen_ivan_chai, BurntForest=gen_ivan_chai, BurntForest=gen_ivan_chai, BGDeepForest=gen_ivan_chai,BGRocky=gen_ivan_chai,
BGDeciduous=gen_ivan_chai,BGForest=gen_ivan_chai,BGCrappyFores=gen_ivan_chai,


BeeClearing = gen_ivan_chai_bee, BeeQueenBee = gen_ivan_chai_bee,


BGMudRoom = gen_ivan_chai_cave, BGMud = gen_ivan_chai_cave
})
GLOBAL.terrain.filter.des_ivan_chai_tree = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER}

AddThingtoWorldGeneration("des_chai_tree",{BarePlain = gen_tea_trees,BGSavanna = gen_tea_trees, BGGrass=gen_tea_trees,
BurntForest=gen_tea_trees, BurntForest=gen_tea_trees, BGDeepForest=gen_tea_trees,BGRocky=gen_tea_trees,
BGDeciduous=gen_tea_trees,BGForest=gen_tea_trees,BGCrappyFores=gen_tea_trees,


BeeClearing = gen_tea_trees_bee, BeeQueenBee = gen_tea_trees_bee,


BGMudRoom = gen_tea_trees_cave, BGMud = gen_tea_trees_cave
})
GLOBAL.terrain.filter.des_chai_tree = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER}


----, BGMud = gen_tea_trees_cave
----, BGMud = gen_ivan_chai_cave
------------------------------------------------
------------------RIVER OWNERS------------------
------------------------------------------------
local gen_water = 1
local gen_water_owners = 0.20
local gen_water_wells = 0.05
----gen_water_owners = 0.25 givrs ~55 owners at generic map
----AddThingtoWorldGeneration("hmato_planted",{BarePlain = gen_holes,BGSavanna = gen_holes, BGGrass=gen_holes, BurntForest=gen_holes, BurntForest=gen_holes, BGDeepForest=gen_holes, BGDeciduous=gen_holes,BGForest=gen_holes,BGCrappyFores=gen_holes})

AddThingtoWorldGeneration("des_river_owner",{BurntForest=gen_water_owners, BurntForest=gen_water_owners,
BGForest=gen_water_owners,BGCrappyFores=gen_water_owners,
BGGrass = gen_water_owners, FlowerPatch = gen_water_owners,
BGSavanna = gen_water_owners, Plain=gen_water_owners, BarePlain =gen_water_owners,
BGRocky = gen_water_owners, Rocky = gen_water_owners, GenericRockyNoThreat = gen_water_owners,

BGMudRoom = gen_water_owners, BGMud = gen_water_owners
})
GLOBAL.terrain.filter.des_river_owner = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER}

------------------------------------------------
-------------------WELL HOLES-------------------
------------------------------------------------
local gen_water_wells = 0.10
----gen_water_owners = 0.25 givrs ~55 owners at generic map
AddThingtoWorldGeneration("des_well_hole",{BurntForest=gen_water_wells, BurntForest=gen_water_wells,
BGForest=gen_water_wells,BGCrappyFores=gen_water_wells,
BGGrass = gen_water_wells, FlowerPatch = gen_water_wells,
BGSavanna = gen_water_wells, Plain=gen_water_wells, BarePlain =gen_water_wells,
BGRocky = gen_water_wells, Rocky = gen_water_wells, GenericRockyNoThreat = gen_water_wells,

BGMudRoom = gen_water_wells, BGMud = gen_water_wells
})
GLOBAL.terrain.filter.des_well_hole = {GLOBAL.GROUND.ROAD, GLOBAL.GROUND.WOODFLOOR, GLOBAL.GROUND.CARPET, GLOBAL.GROUND.CHECKER}

------------------------------------------------
------------------------------------------------
------------------------------------------------




local require = GLOBAL.require
require("map/lockandkey")

local LOCKS = GLOBAL.LOCKS
local KEYS = GLOBAL.KEYS
local GROUND = GLOBAL.GROUND
local Layouts = GLOBAL.require("map/layouts").Layouts
local StaticLayout = GLOBAL.require("map/static_layout")
-------des_max_fountain


Layouts["des_max_fountain"] = StaticLayout.Get("map/static_layouts/des_max_fountain")
Layouts["des_well_preset"] = StaticLayout.Get("map/static_layouts/des_well_preset")


local function LevelPreInit(level)
	table.insert(level.tasks, "des_max_fountain_ADD")
	---table.insert(level.tasks, "des_well_ADD")

end

AddLevelPreInitAny(LevelPreInit)
------------------------------------------------------------------------
--------------------------------------------------------------------------
--------------------------------------------------------------------------

	
	
AddTask("des_max_fountain_ADD", {
		locks=LOCKS.NONE,
		keys_given=KEYS.NONE,
		room_choices={
			["des_max_fountain"] = 1,
		},
		room_bg = GROUND.TILES,
		background_room="BGDeciduous",
		colour={r=1,g=0,b=0.6,a=1},
	})	
	
AddRoom("des_max_fountain", {
					colour={r=0.9,g=.9,b=.2,a=.50},
					value = GROUND.DECIDUOUS,
					-----tags = {"Town"},
					contents =  {
									countstaticlayouts=
									{
										["des_max_fountain"]=1,
									},
					            }
					})
					
AddTask("des_well_ADD", {
		locks=LOCKS.NONE,
		keys_given=KEYS.NONE,
		room_choices={
			["des_well_preset"] = 1,
		},
		room_bg = GROUND.TILES,
		background_room="BGMarsh",
		colour={r=1,g=0,b=0.6,a=1},
	})	
	
AddRoom("des_well_preset", {
					colour={r=0.9,g=.9,b=.2,a=.50},
					value = GROUND.MARSH,
					-----tags = {"Town"},
					contents =  {
									countstaticlayouts=
									{
										["des_well_preset"]=1,
									},
					            }
					})					
					
					
					
					
--[[
AddRoom("pigqueen", {
					colour={r=0.9,g=.9,b=.2,a=.50},
					value = GROUND.ROCKY,
					tags = {"Town"},
					contents =  {
									countstaticlayouts=
									{
										["pigqueen"]=1,
									},
					            }
					})

--------------------------------------------------------------------------
if GetModConfigData("force_config") then
    local function RequireQueen(level)	
        table.insert(level.required_prefabs, "pigqueen")
    end
    AddLevelPreInit("SURVIVAL_TOGETHER", RequireQueen)
end--]]









