local des_abi_inv = Class(function(self, inst)
    self.inst = inst
end)
--------------------------
--------------------------
--------------------------
--------------------------
-- 1st slot always contains fake_drop
-- 2nd slot can only contain zavarka
-- заварка забирается сразу при постановке на огонь
-- пока чайник на огне вода превращается в напиток
-- вся лишняя вода исчезнет из чайника
-- нужно 50 воды на 1 заварку??
-- 3rd слот всегда показывает, какой напиток внутри и сколько его
-- 4 слот залить воды в чайник
-- 5 слот вылить вообще всё из чайника
-- 6 слот позволяет набрать напиток
--------------------------
--------------------------
--------------------------
--------------------------

local list = 
{
	EQUIPSLOTS.HANDS,
	EQUIPSLOTS.BODY,
	EQUIPSLOTS.HEAD,
	EQUIPSLOTS.HANDS
}

function des_abi_inv:IsSlotValid(item, slot)


end

function des_abi_inv:IsSlotValid(item, slot)
	local inst = self.inst

	if not item then
		item = inst.components.container:GetItemInSlot(slot)
		if not item then
			return
		end
	end
	
	if item.components.equippable == nil and slot <=4 then
		return
	end

	if list[slot] == item.components.equippable.equipslot then
		return true
	else 
		return
	end
end

function des_abi_inv:GetValidSlot(item)
	local inst = self.inst
	if not item then
		--item = inst.components.container:GetItemInSlot(slot)
		--if not item then
			return
	--	end
	end
	if item.components.equippable == nil then
		for x=6,12,1 do
			if inst.components.container:GetItemInSlot(x) == nil then
				return x
			end
		end
	else
		for x=1,4,1 do
			if inst.components.container:GetItemInSlot(x) == nil and list[x] == item.components.equippable.equipslot then
				return x
			end
		end
	end
	return

end


function des_abi_inv:ValidateEquipment()
	local old_slot = 1
	local inst = self.inst

	for x=1,4,1 do
		print("ValidateEquipment82---- x = "..x)
		if self:IsSlotValid(nil, x) == nil then
			local item = inst.components.container:GetItemInSlot(x)
			if item then
				print("INVALID ITEM  "..x.." item - "..item.prefab)

				if self:GetValidSlot(item) then
					print("Valid slot for "..item.prefab.." x="..self:GetValidSlot(item))
					self:SwitchItemSlots(inst, item, self:GetValidSlot(item))
				else
					---drop it cause no place in INV
					inst.components.container:Close()
					inst.components.container:DropItem(item)
				end
			end
		end
		
		local item_e = inst.components.container:GetItemInSlot(x)
		if x~= 4 and self:IsSlotValid(nil, x) and item_e ~= inst.components.inventory:GetItemInSlot(list[x]) then
			print("ValidateEquipment101  "..x.." item - "..item_e.prefab)

			inst.components.inventory:Equip(item_e)
		end
		--]]
	end
	---inst.components.inventory:Equip(item)
	
	
end

function des_abi_inv:DropRemove(item, slot, donotremove)
	if (not item) and (not slot) then return end
	local inst = self.inst
	
	if not slot and item then
		slot = 1
		----find item original slot
		for x=1,12,1 do
			if inst.components.container:GetItemInSlot(x) == item then
				slot = x
			end
		end
	elseif slot and not item then
		item = inst.components.container:GetItemInSlot(slot)
	end
	
	if slot and item then
		inst.components.container:DropItemBySlot(slot)
		if donotremove then
		else
			item:Remove()
		end
	end	
end


function des_abi_inv:SwitchItemSlots(inst1, item, to_slot)
	local inst = inst1 or self.inst
	if not item then return end
	local old_slot = 1
	----find item original slot
	for x=1,12,1 do
		if inst.components.container:GetItemInSlot(x) == item then
			old_slot = x
		end
	end
	
	
	 inst.components.container:Close()
	-- --if item.components.stackable and item.components.stackable.stacksize >1 then
		-- --for y = 1, item.components.stackable.stacksize, 1 do
			-- --local to_slot_drop = inst.components.container:GetItemInSlot(old_slot)

			-- inst.components.container:DropItem(to_slot_drop)
			-- inst.components.container:GiveItem(to_slot_drop, to_slot)
		-- end
	-- else
		inst.components.container:DropItemBySlot(old_slot)
		
		local to_slot_item = inst.components.container:GetItemInSlot(to_slot)
		
		if to_slot_item then
			---there is something already, switch slots
			inst.components.container:DropItemBySlot(to_slot)
			
			inst:DoTaskInTime(0, function()
				inst.components.container:GiveItem(to_slot_item, old_slot)
			end)
				
		end--]]
		inst:DoTaskInTime(0, function()
			inst.components.container:GiveItem(item, to_slot)
		end)
	
end




function des_abi_inv:fake_put_to_chest(chest, item, slot)
	chest.AnimState:PlayAnimation("open")
	chest.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")

	
	self:DropRemove(item, slot, true)
	self.inst:DoTaskInTime(0, function()
		chest.components.container:GiveItem(item)
	end)
	
	self.inst:DoTaskInTime(1, function()
		chest.AnimState:PlayAnimation("close")
		chest.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	end)
end







return des_chainik_c