return {
  version = "1.1",
  luaversion = "5.1",
  orientation = "orthogonal",
  width = 10,
  height = 10,
  tilewidth = 64,
  tileheight = 64,
  properties = {},
  tilesets = {
    {
      name = "ground",
      firstgid = 1,
      filename = "../../../../tools/tiled/dont_starve/ground.tsx",
      tilewidth = 16,
      tileheight = 16,
      spacing = 0,
      margin = 0,
      image = "../../../../tools/tiled/dont_starve/tiles.png",
      imagewidth = 512,
      imageheight = 384,
      properties = {},
      tiles = {}
    }
  },
  layers = {
    {
      type = "tilelayer",
      name = "BG_TILES",
      x = 0,
      y = 0,
      width = 10,
      height = 10,
      visible = true,
      opacity = 1,
      properties = {},
      encoding = "lua",
      data = {
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
        0, 10, 0, 0, 0, 0, 0, 0, 10, 0,
        0, 10, 10, 11, 11, 11, 11, 11, 10, 0,
        0, 0, 11, 10, 10, 11, 10, 10, 11, 0,
        0, 10, 10, 0, 0, 0, 0, 10, 10, 10,
        0, 0, 11, 10, 10, 11, 10, 10, 11, 0,
        0, 0, 0, 11, 11, 11, 11, 11, 0, 0,
        0, 0, 10, 0, 0, 0, 0, 10, 0, 0,
        0, 10, 0, 0, 0, 0, 0, 0, 10, 0,
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0

      }
    },
    {
      type = "objectgroup",
      name = "FG_OBJECTS",
      visible = true,
      opacity = 1,
      properties = {},
      objects = {
        {
          name = "Cherub Statue",
          type = "statueharp",
          shape = "rectangle",
          x = 545,
          y = 222,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Cherub Statue",
          type = "statueharp",
          shape = "rectangle",
          x = 156,
          y = 350,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Mined Knight",
          type = "sculpture_knightbody",
          shape = "rectangle",
          x = 349,
          y = 407,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Mined Knight",
          type = "sculpture_knightbody",
          shape = "rectangle",
          x = 347,
          y = 148,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Cherub Statue",
          type = "statueharp",
          shape = "rectangle",
          x = 543,
          y = 347,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Cherub Statue",
          type = "statueharp",
          shape = "rectangle",
          x = 154,
          y = 218,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Fountain",
          type = "des_statue_charlie",
          shape = "rectangle",
          x = 348,
          y = 271,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 271,
          y = 302,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 286,
          y = 276,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 262,
          y = 260,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 303,
          y = 303,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 314,
          y = 269,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 382,
          y = 301,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 342,
          y = 302,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 385,
          y = 267,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 419,
          y = 269,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 406,
          y = 292,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 427,
          y = 308,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 440,
          y = 282,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 440,
          y = 258,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 321,
          y = 289,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
		
        {
          name = "Muse statue",
          type = "chesspiece_muse_marble",
          shape = "rectangle",
          x = 213,
          y = 175,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Muse statue",
          type = "chesspiece_muse_marble",
          shape = "rectangle",
          x = 491,
          y = 172,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },--]]
        {
          name = "Clockwork Knight",
          type = "knight",
          shape = "rectangle",
          x = 210,
          y = 401,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Clockwork Knight",
          type = "knight",
          shape = "rectangle",
          x = 491,
          y = 402,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Clockwork Knight",
          type = "knight",
          shape = "rectangle",
          x = 130,
          y = 283,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Clockwork knight",
          type = "knight",
          shape = "rectangle",
          x = 565,
          y = 281,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 135,
          y = 141,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 155,
          y = 164,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 174,
          y = 140,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 136,
          y = 178,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 171,
          y = 177,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 525,
          y = 138,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 523,
          y = 172,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 564,
          y = 138,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 560,
          y = 169,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 135,
          y = 397,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 155,
          y = 417,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 176,
          y = 394,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 133,
          y = 434,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 174,
          y = 433,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 526,
          y = 397,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 549,
          y = 415,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 570,
          y = 395,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 565,
          y = 438,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 529,
          y = 432,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 176,
          y = 411,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 544,
          y = 392,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 545,
          y = 432,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        },
        {
          name = "Rose",
          type = "flower_rose",
          shape = "rectangle",
          x = 363,
          y = 290,
          width = 0,
          height = 0,
          visible = true,
          properties = {}
        }
      }
    }
  }
}
