local assets =
{
    Asset("ANIM", "anim/aquagem.zip"),
}

local function buildgem(colour)


    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddNetwork()

        MakeInventoryPhysics(inst)
		inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

        inst.AnimState:SetBank("aquagem")
        inst.AnimState:SetBuild("aquagem")
        inst.AnimState:PlayAnimation("gem_idle", true)

        inst:AddTag("molebait")
        inst:AddTag("quakedebris")

        inst.entity:SetPristine()
		
		local s = 2	
		inst.Transform:SetScale(s,s,s )
		
        if not TheWorld.ismastersim then
            return inst
        end

        inst:AddComponent("edible")
        inst.components.edible.foodtype = FOODTYPE.ELEMENTAL
        inst:AddComponent("tradable")
        inst.components.edible.hungervalue = 5

        inst:AddComponent("bait")

       -- inst:AddComponent("repairer")
    --    inst.components.repairer.repairmaterial = MATERIALS.GEM
     --   inst.components.repairer.workrepairvalue = TUNING.REPAIR_GEMS_WORK

        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname = "images/inventoryimages/aquagem.xml"
		inst.components.inventoryitem.imagename = "aquagem"
		
        MakeHauntableLaunchAndSmash(inst)

        return inst
    end
    return Prefab("aquagem_thirst", fn, assets)
end

return buildgem("aquagem_thirst")