local assets =
{
    Asset("ANIM", "anim/des_chai_tabl.zip"),
}

local assets_two =
{
    Asset("ANIM", "anim/des_chai_tabl_two.zip"),
}

local assets_three =
{
    Asset("ANIM", "anim/des_chai_tabl_three.zip"),
}

local function buildtea(name, num)


    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddNetwork()

        MakeInventoryPhysics(inst)
		--inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

		if num == 1 then
        inst.AnimState:SetBank("des_chai_tabl")
        inst.AnimState:SetBuild("des_chai_tabl")
		elseif num == 2 then
        inst.AnimState:SetBank("des_chai_tabl_two")
        inst.AnimState:SetBuild("des_chai_tabl_two")
		elseif num == 3 then
        inst.AnimState:SetBank("des_chai_tabl_three")
        inst.AnimState:SetBuild("des_chai_tabl_three")
		end
		
        inst.AnimState:PlayAnimation(name, true)

        inst:AddTag("molebait")
        inst:AddTag("des_zavarka")
		
		
        inst.entity:SetPristine()
		
		local s = 2	
		inst.Transform:SetScale(s,s,s )
		
        if not TheWorld.ismastersim then
            return inst
        end

		inst:AddComponent("des_throw_in")
		

        inst:AddComponent("bait")

       -- inst:AddComponent("repairer")
    --    inst.components.repairer.repairmaterial = MATERIALS.GEM
     --   inst.components.repairer.workrepairvalue = TUNING.REPAIR_GEMS_WORK

        inst:AddComponent("stackable")
        inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

        inst:AddComponent("inspectable")

        inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.atlasname = "images/inventoryimages/des_chai_tabl_"..name..".xml"
		inst.components.inventoryitem.imagename = "des_chai_tabl_"..name
		
        MakeHauntableLaunchAndSmash(inst)

        return inst
    end
	
	
	if num == 1 then
		return Prefab("des_chai_tabl_"..name, fn, assets)
	elseif num == 2 then
		return Prefab("des_chai_tabl_"..name, fn, assets_two)
	elseif num == 3 then
		return Prefab("des_chai_tabl_"..name, fn, assets_three)
	end
end

return buildtea("black",1),
buildtea("green",1),
buildtea("ivan",1),
buildtea("coffee",1),
buildtea("shadow",2),
buildtea("stinger",2),
buildtea("pine",2),
buildtea("coal",2),
buildtea("dragonheal",3),
buildtea("glommerhunger",3),
buildtea("honeysanity",3),
buildtea("fishwet",3)