local assets =
{
	Asset("ANIM", "anim/hmato.zip"),
}

local prefabs =
{
	"hmato_item",
}

local function fn()
    --Carrot you eat is defined in veggies.lua
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()

    inst.AnimState:SetBank("hmato")
    inst.AnimState:SetBuild("hmato")
    inst.AnimState:PlayAnimation("ground")
    inst.AnimState:SetRayTestOnBB(true)
	
    inst.Transform:SetScale(2.25, 2.25, 2.25)
	
	if not TheWorld.ismastersim then
       return inst
    end
	
	inst.entity:SetPristine()

	
    inst:AddComponent("inspectable")

    inst:AddComponent("pickable")
    inst.components.pickable.picksound = "dontstarve/wilson/pickup_plants"
    inst.components.pickable:SetUp("hmato_item", 10)
	inst.components.pickable.onpickedfn = inst.Remove
	


    inst.components.pickable.quickpick = true
    
	MakeSmallBurnable(inst)
    MakeSmallPropagator(inst)

    return inst
end

return Prefab("common/inventory/hmato_planted", fn, assets)