    
local assets =
{
---	Asset("ANIM", "anim/sign_home.zip"),
	Asset("ANIM", "anim/blocker.zip"),
}

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	SpawnPrefab("collapse_big").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("idle")
end


    
local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	   
    MakeObstaclePhysics(inst, .2)    
    
   --[[ 
    anim:SetBank("sign_home")
    anim:SetBuild("sign_home")
    anim:PlayAnimation("idle")
    --]]
	local anims = {"block1", "block4", "block2"}
        inst.animname = anims[math.random(#anims)]
        anim:SetBank("blocker")
        anim:SetBuild("blocker")
        anim:PlayAnimation(inst.animname)
        local color = 0.5 + math.random() * 0.5
        anim:SetMultColour(color, color, color, 1)
		
    inst:AddTag("NOCLICK")
	
    inst.Transform:SetScale(.2, .2, .2 )

 	MakeSnowCovered(inst, .01)	
   
    return inst
end

return Prefab( "common/objects/pondbuildsign", fn, assets)
